/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function CorrectWrongObserver(sId)
{
  if (sId) { this.init(sId); }
}
CorrectWrongObserver.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.aIncompleteActions = new Array();
  this.aCompleteActions = new Array();
  this.aCompleteWithoutHelpActions = new Array();
  this.excStatus = null;
}
CorrectWrongObserver.prototype.getId = function()
{
  return this.sId;
}
CorrectWrongObserver.prototype.registerCompleteAction = function(completeAction)
{
  this.aCompleteActions.push(completeAction);
}
CorrectWrongObserver.prototype.registerCompleteWithoutHelpAction = function(completeAction)
{
  this.aCompleteWithoutHelpActions.push(completeAction);
}
CorrectWrongObserver.prototype.registerIncompleteAction = function(incompleteAction)
{
  this.aIncompleteActions.push(incompleteAction);
}
CorrectWrongObserver.prototype.solved = function(excStatus)
{
  this.excStatus = excStatus;
}
CorrectWrongObserver.prototype.getSendAction = function()
{
  return new ObjectMethodAction(this, "send");
}
CorrectWrongObserver.prototype.send = function()
{
  if ( this.excStatus &&
          this.excStatus.nCorrect == this.excStatus.nCorrectStatus &&
          this.excStatus.nCorrectSystem == 0 && this.excStatus.nWrongSystem == 0 &&
          this.excStatus.nWrongStatus == 0 &&
          this.excStatus.nTotal == this.excStatus.nTouched)
  {
    this.invokeActions(this.aCompleteWithoutHelpActions);
    this.invokeActions(this.aCompleteActions);
  }
  else if ( this.excStatus &&
          this.excStatus.nCorrect == this.excStatus.nCorrectStatus &&
          this.excStatus.nWrongStatus == 0 &&
          this.excStatus.nTotal == this.excStatus.nTouched)
  {
    this.invokeActions(this.aCompleteActions);
  }
  else
  {
    this.invokeActions(this.aIncompleteActions);
  }
}
CorrectWrongObserver.prototype.invokeActions = function(aActions)
{
    if ( aActions.length )
    {
      for ( var i = 0; i < aActions.length; i++)
      {
        aActions[i].invoke();
      }
    }
}
CorrectWrongObserver.prototype.getSolvedAction = function()
{
  return new ObjectMethodAction(this, "solved");
}
