/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ContentLoader</DEPENDS>
</DEPENDENCIES>
*/
function ContentLoader(sId, sWidgetDomId, sURL)
{
  if (sId) { this.init(sId, sWidgetDomId, sURL); }
}
ContentLoader.prototype.init = function(sId, sWidgetDomId, sURL)
{
  ;
  this.sId = sId;
  this.sURL = sURL;
  this.bHasContent = false;
  this.bShowContent = false;
  this.bLoading = false; 
  this.xmlDoc = null;
  this.jsscript = null;
  this.loadedCallbackAction = null;
  this.aRecursiveContentLoaders = new Array();
  this.oWidget = document.getElementById(sWidgetDomId);
  this.sWidgetDomId = sWidgetDomId;
  if ( ! this.oWidget )
  {
    ;
  }
}
ContentLoader.prototype.setURL = function(sUrl)
{
  this.sURL = sURL;
  this.bHasContent = false;
}
ContentLoader.prototype.setLoadedCallback = function(loadedCallbackAction)
{
  this.loadedCallbackAction = loadedCallbackAction;
}
ContentLoader.prototype.loadContent = function()
{
  if ( ! this.bLoading )
  {
    this.bLoading = true;
    me = this;
    loadDocCallback = function ()
    {
      me.loaded();
    }
    this.xmlDoc = document.implementation.createDocument("", "", null);
    this.xmlDoc.onload = loadDocCallback;
    this.xmlDoc.load(this.sURL);
  }
}
ContentLoader.prototype.loaded = function()
{
  this.bHasContent = true;
  this.bLoading = false;
  if( this.bShowContent )
  {
    this.showContent();
  }
}
ContentLoader.prototype.hideEmpty = function()
{
  this.bShowContent = false;
  this.oWidget.innerHTML = '';
  this.oWidget.style.visibility = 'hidden';
}
ContentLoader.prototype.loadIncludesCallback = function()
{
  if ( this.aRecursiveContentLoaders.length )
  {
    var oActiveRecursiveContentLoader = this.aRecursiveContentLoaders.shift();
    oActiveRecursiveContentLoader.showContent();
  }
  else
  {
    this.addContent()
  }
}
ContentLoader.prototype.addContent = function()
{
  this.bShowContent = false;
  var html = this.xmlDoc.getElementsByTagName('html');
  var javascript = this.xmlDoc.getElementsByTagName('javascript');
  var window = this.xmlDoc.getElementsByTagName('window');
  for( var i = 0; i < window.length; i++)
  {
    for( var j = 0; j < window[i].attributes.length; j++)
    {
      this.oWidget.style[window[i].attributes[j].localName] = window[i].attributes[j].value;
    }
  }
  for( var i = 0; i < html.length; i++)
  {
    for( var j = 0; j < html[i].childNodes.length; j++)
    {
      this.oWidget.innerHTML += html[i].childNodes[j].data;
    }
  }
  for( var i = 0; i < javascript.length; i++)
  {
    for( var j = 0; j < javascript[i].childNodes.length; j++)
    {
      this.jsscript += javascript[i].childNodes[j].data;
    }
  }
  if ( this.loadedCallbackAction )
  {  
    this.loadedCallbackAction.invoke();
  }
  else
  {
    this.oWidget.style.visibility = 'visible';
    Browser.setToplevel(this.oWidget);
    eval(this.jsscript);
  }
}
ContentLoader.prototype.showContent = function()
{
  if ( this.bHasContent )
  {
    this.bShowContent = false;
    var include = this.xmlDoc.getElementsByTagName('include');
    if ( ! this.loadedCallbackAction )
    {
      this.oWidget.innerHTML = '';
      this.jsscript = null;
    }
    for( var i = 0; i < include.length; i++)
    {
      for( var j = 0; j < include[i].attributes.length; j++)
      {
        if (include[i].attributes[j].name == 'src')
        {
          var recursiveContentLoader = new ContentLoader(this.sId + 'recursive_include_1', this.sWidgetDomId, include[i].attributes[j].value);
          recursiveContentLoader.setLoadedCallback(this.getLoadIncludesCallbackAction());
          this.aRecursiveContentLoaders.push(recursiveContentLoader);
        }
      }
    }
    this.loadIncludesCallback();
  } 
  else
  {
    this.bShowContent = true;
    this.loadContent();
  }
}
ContentLoader.prototype.getShowContentAction = function()
{
    return new ObjectMethodAction(this, "showContent", false);
}
ContentLoader.prototype.getHideEmptyAction = function()
{
    return new ObjectMethodAction(this, "hideEmpty", false);
}
ContentLoader.prototype.getLoadContentAction = function()
{
    return new ObjectMethodAction(this, "loadContent", false);
}
ContentLoader.prototype.getSetURLAction = function()
{
    return new ObjectMethodAction(this, "setURL", false);
}
ContentLoader.prototype.getLoadIncludesCallbackAction = function()
{
    return new ObjectMethodAction(this, "loadIncludesCallback", false);
}
