/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
</DEPENDENCIES>
*/
function Tooltip(groupName, sText, sDomId, sCssClass)
{
	if (!groupName)
		groupName = 'DEFAULT';
	this.tooltip = Tooltip_getInstance('SimpleTooltipGroup_' + groupName);
	this.tooltip.setPosOffset(2, -2);
	this.sDomId = sDomId;
	this.sCssClass = sCssClass;
	if (sText && sDomId && sCssClass)
		this.tooltip.registerTooltip(sText, sDomId, sCssClass);
}
Tooltip.prototype.setHideTimeout = function(nHideTimeout)
{
	this.tooltip.setHideTimeout(nHideTimeout);
}
Tooltip.prototype.setShowTimeout = function(nShowTimeout)
{
	this.tooltip.setShowTimeout(nShowTimeout);
}
Tooltip.prototype.getChangeTooltipTextAction = function(tooltiptext)
{
	return new ObjectMethodAction(this, "changeTooltipText", tooltiptext);
}
Tooltip.prototype.changeTooltipText = function(tooltiptext)
{
	this.sText = tooltiptext;
	if (this.sText && this.sDomId && this.sCssClass)
	{
		var domlet = this.tooltip.domlets[this.sDomId];
		if (domlet != null && domlet != undefined)
		{
			function Container(sText, sDomId, sCssClass, nIndex)
			{
				this.sText = sText;
				this.sDomId = sDomId;
				this.sCssClass = sCssClass;
				this.nIndex = nIndex;
			}
			domlet.tooltipData = new Container(this.sText, this.sDomId, this.sCssClass);
			this.tooltip.oWidget.innerHTML = tooltiptext;
		}
	}
}
SimpleTooltip.prototype = new DomletCtr();
SimpleTooltip.prototype.constructor = SimpleTooltip;
SimpleTooltip.superclass = DomletCtr.prototype;
var staticTooltip = new Array;
Tooltip_getInstance = function(sId)
{
	var Instance = null;
	if (staticTooltip[sId])
	{
		Instance = staticTooltip[sId];
	}
	else
	{
		Instance = new SimpleTooltip(sId);
	}
	return Instance;
}
function SimpleTooltip(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
SimpleTooltip.prototype.init = function(sId)
{
	;
	this.sId = sId;
	this.XOffset = null;
	this.YOffset = null;
	this.nWidth = null;
	this.nHeight = null;
	this.nHideTipTimeoutId = null;
	this.nShowTipTimeoutId = null;
	this.nShowTimeout = 1000;
	this.nHideTimeout = 4000;
	staticTooltip[sId] = this;
	this.sWidgetDomId = sId + 'tooltip_dyn_div';
	this.oWidget = document.createElement("DIV");
	this.oWidget.id = this.sWidgetDomId;
	this.oWidget.style.visibility = 'hidden';
	this.oWidget.style.position = 'absolute';
	document.body.appendChild(this.oWidget);
	SimpleTooltip.superclass.init.call(this, this.sWidgetDomId, this.sId, this);
}
SimpleTooltip.prototype.getId = function()
{
	;
	return this.sId;
}
SimpleTooltip.prototype.setShowTimeout = function(nShowTimeout)
{
	;
	this.nShowTimeout = nShowTimeout;
}
SimpleTooltip.prototype.registerTooltip = function(sText, sDomId, sCssClass)
{
	;
	function Container(sText, sDomId, sCssClass, nIndex)
	{
		this.sText = sText;
		this.sDomId = sDomId;
		this.sCssClass = sCssClass;
		this.nIndex = nIndex;
	}
	var tooltipWidget = document.getElementById(sDomId);
	if (tooltipWidget == null)
	{
		;
	}
	else
	{
		var Container = new Container(sText, sDomId, sCssClass)
		var domlet = new Domlet(
				sDomId, 
				sDomId, 
				this, 
				new Array('mouseover', 'mouseout', 'mousemove', 'click'))	
		domlet.tooltipData = Container;
		this.addDomlet(domlet);
	}
}
SimpleTooltip.prototype.setPosOffset = function(nXOffset, nYOffset)
{
	;
	this.XOffset = nXOffset;
	this.YOffset = nYOffset;
}
SimpleTooltip.prototype.setHideTimeout = function(nHideTimeout)
{
	;
	this.nHideTimeout = nHideTimeout;
}
SimpleTooltip.prototype.eventFromChild = function(childName, eventType, event)
{
	////;
	var domlet = this.domlets[childName];
	switch (eventType)
			{
		case "mouseover" :
			;
			this.mouseoverHandler(domlet, event);
			break;
		case "mousemove" :
			;
			this.mousemoveHandler(domlet, event);
			break;
		case "mouseout" :
			;
			this.mouseoutHandler(domlet, event);
			break;
	}
}
SimpleTooltip.prototype.mouseoverHandler = function(domlet, event)
{
	;
	this.oWidget.style.top = "0px";
	this.oWidget.style.left = "0px";
	this.oWidget.innerHTML = domlet.tooltipData.sText;
	this.oWidget.className = domlet.tooltipData.sCssClass;
	this.nWidth = this.oWidget.offsetWidth;
	this.nHeight = this.oWidget.offsetHeight;
	this.moveTooltip(event.clientX, event.clientY);
	
	
	this.nShowTipTimeoutId = window.setTimeout('Tooltip_getInstance(\'' + this.sId + '\').showTooltip();', this.nShowTimeout);
	if (this.nHideTipTimeoutId)
	{
		clearTimeout(this.nHideTipTimeoutId);
		this.nHideTipTimeoutId = null;
	}
}
SimpleTooltip.prototype.showTooltip = function()
{
	;
	if (this.nHideTipTimeoutId)
	{
		clearTimeout(this.nHideTipTimeoutId);
		this.nHideTipTimeoutId = null;
	}
	if (this.nShowTipTimeoutId)
	{
		clearTimeout(this.nShowTipTimeoutId);
		this.nShowTipTimeoutId = null;
	}
	this.oWidget.style.visibility = 'visible';
	Browser.setToplevel(this.oWidget);
	if (this.nHideTimeout)
	{
		this.nHideTipTimeoutId = window.setTimeout('Tooltip_getInstance(\'' + this.sId + '\').mouseoutHandler();', this.nHideTimeout);
	}
}
SimpleTooltip.prototype.moveTooltip = function(cursorX, cursorY)
{
	;
	var firstDiv = document.getElementsByTagName("div")[0];
	
	var body = document.body;
	
	var top = 0;
	top = cursorY + this.YOffset - this.nHeight + parseInt(Browser.getBodyScrollTop()) - 5;
	if (top < 0)
	{
		top = cursorY + this.YOffset + parseInt(Browser.getBodyScrollTop()) + 3;
	}
	
	var left = 0;
	if ((cursorX + this.XOffset + this.nWidth + 5) > firstDiv.offsetWidth + body.scrollLeft) 
	{
		
		left = cursorX - this.XOffset - this.nWidth - 5;
		if (left < 0)
			left = 0;
	}
	else
	{
		
		left = cursorX + this.XOffset;
	}
	Browser.changePixelStyle(this.oWidget, 'top', top);
	Browser.changePixelStyle(this.oWidget, 'left', left);
}
SimpleTooltip.prototype.mousemoveHandler = function(domlet, event)
{
	;
	this.moveTooltip(event.clientX, event.clientY);
}
SimpleTooltip.prototype.mouseoutHandler = function(domlet, event)
{
	;
	if (this.nHideTipTimeoutId)
	{
		clearTimeout(this.nHideTipTimeoutId);
		this.nHideTipTimeoutId = null;
	}
	if (this.nShowTipTimeoutId)
	{
		clearTimeout(this.nShowTipTimeoutId);
		this.nShowTipTimeoutId = null;
	}
	this.oWidget.style.visibility = 'hidden';
}
