/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>FormReplaceSubmitHandler</DEPENDS>
    <DEPENDS>FormPopupSubmitHandler</DEPENDS>
    <DEPENDS>FormOpenWindowSubmitHandler</DEPENDS>
    <DEPENDS>FormBackgroundSubmitHandler</DEPENDS>
    <DEPENDS>FormCBTSubmitHandler</DEPENDS>
    <DEPENDS>ServerResultAdapter</DEPENDS>
</DEPENDENCIES>
*/
function Form(sId, sUrlBase)
{
  if (sId) { this.init(sId, sUrlBase); }
}
Form.prototype.init = function(sId, sUrlBase)
{
  ;   
  this.aKeyVal = new Array();
  this.sId = sId;
  this.sUrlBase = sUrlBase;
  this.flushAfterSend = false;
  this.submitHandler = null;
}
Form.prototype.setSubmitHandler = function(submitHandler)
{
  ;
  this.submitHandler = submitHandler;
}
Form.prototype.getId = function()
{
  ;
  return this.sId;
}
Form.prototype.setFlushAfterSend = function(flushAfterSend)
{
  ;
  this.flushAfterSend = flushAfterSend;
}
Form.prototype.send = function()
{
  ;
    var tmpKeyVal = new Array;
    tmpKeyVal = this.aKeyVal;
    if ( this.flushAfterSend )
    {
      this.aKeyVal = new Array();
    }
    var URL = this.sUrlBase;
    for ( var key in tmpKeyVal )
    {
      URL += '&' + key + '=' + encodeURIComponent(tmpKeyVal[key]);
    }
    ;
    this.submitHandler.invoke(URL);
}
Form.prototype.addValueMap = function(oValueMap)
{
  ;
  for ( var key in oValueMap.aArray )
  {
    this.aKeyVal[key] =  oValueMap.aArray[key];
  }
  if ( oValueMap.bSend )
  {
    this.send();
  }
}
Form.prototype.addKeyValue = function(key, value)
{
  ;
  this.aKeyVal[key] = value;
}
Form.prototype.getSendAction = function()
{
  return new ObjectMethodAction(this, 'send');
}
Form.prototype.getAddValueMapAction = function(oValueMap)
{
  return new ObjectMethodAction(this, 'addValueMap', oValueMap);
}
function FormBackgroundSubmitHandler(sId)
{
  if (sId) { this.init(sId); }
}
FormBackgroundSubmitHandler.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.screenBroker = null;
}
FormBackgroundSubmitHandler.prototype.setScreenBroker = function(screenBroker)
{
  this.screenBroker = screenBroker;
}
FormBackgroundSubmitHandler.prototype.invoke = function(url)
{
    this.screenBroker.invokeServletMethod(url);
}
function FormReplaceSubmitHandler(sId)
{
  if (sId) { this.init(sId); }
}
FormReplaceSubmitHandler.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.screenBroker = null;
}
FormReplaceSubmitHandler.prototype.setScreenBroker = function(screenBroker)
{
  this.screenBroker = screenBroker;
}
FormReplaceSubmitHandler.prototype.invoke = function(url)
{
    this.screenBroker.replace(url);
}
function FormOpenWindowSubmitHandler(sId, target)
{
  if (sId) { this.init(sId, target); }
}
FormOpenWindowSubmitHandler.prototype.init = function(sId, target)
{
  ;
  this.sId = sId;
  this.target = target;
  this.screenBroker = null;
}
FormOpenWindowSubmitHandler.prototype.setScreenBroker = function(screenBroker)
{
  this.screenBroker = screenBroker;
}
FormOpenWindowSubmitHandler.prototype.invoke = function(url)
{
    this.screenBroker.openWindow(url, this.target);
}
function FormPopupSubmitHandler(sId, target, width, height, scrollbars, resizable)
{
  if (sId) { this.init(sId, target, width, height, scrollbars, resizable); }
}
FormPopupSubmitHandler.prototype.init = function(sId, target, width, height, scrollbars, resizable)
{
  ;
  this.sId = sId;
  this.target = target;
  this.width = width;
  this.heigth = height;
  this.scrollbars = scrollbars;
  this.resizable = resizable;
  this.screenBroker = null;
}
FormPopupSubmitHandler.prototype.setScreenBroker = function(screenBroker)
{
  this.screenBroker = screenBroker;
}
FormPopupSubmitHandler.prototype.invoke = function(url)
{
    this.screenBroker.popup(this.sId, url, this.target, this.width, this.height, this.scrollbars, this.resizable);
}
function FormCBTSubmitHandler(sId, pathSystemBrowserStore, contextPath, sessionId, attributename)
{
  if (sId) { this.init(sId, pathSystemBrowserStore, contextPath, sessionId, attributename); }
}
FormCBTSubmitHandler.prototype.init = function(sId, pathSystemBrowserStore, contextPath, sessionId, attributename)
{
  ;
  this.sId = sId;
  this.pathSystemBrowserStore = pathSystemBrowserStore;
  this.sessionId = sessionId;
  this.contextPath = contextPath;
  this.attributename = attributename;
}
FormCBTSubmitHandler.prototype.setScreenBroker = function(screenBroker)
{
  this.screenBroker = screenBroker;
}
FormCBTSubmitHandler.prototype.setResultAdapter = function(resultAdapter)
{
  this.resultAdapter = resultAdapter;
}
FormCBTSubmitHandler.prototype.invoke = function(url)
{
    var urlSystemBrowserStore =
        this.contextPath +
        this.pathSystemBrowserStore +
        '?PATH=' +
        encodeURIComponent(url);
   var promoteAction =
        this.resultAdapter.getPromoteAction(this.attributename, this.screenBroker.getReplaceAction());
   this.screenBroker.getCallServerAction(urlSystemBrowserStore, promoteAction).invoke();
}
