/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Controller</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
</DEPENDENCIES>
*/
KeyEventListener.prototype             = new DomletCtr();
KeyEventListener.prototype.constructor = KeyEventListener;
KeyEventListener.superclass            = DomletCtr.prototype;
function KeyEventListener(sId, sInputWidgetDomId)
{
  if (sId) { this.init(sId, sInputWidgetDomId); }
}
KeyEventListener.prototype.init = function(sId, sInputWidgetDomId)
{
  ;   
  this.sId = sId;
  this.oKeyboardBroker = null;
  this.bHasFocus = false;
  this.bDoBlurAfterUpdate = true;
  KeyEventListener.superclass.init.call(this, this.sInputWidgetDomId, this.sId, this);
  this.inputWidget = document.getElementById(sInputWidgetDomId);
  this.sInputWidgetDomId = sInputWidgetDomId;
  if (this.inputWidget == null)
  {
      ;
  }
  else
  {
    this.addDomlet(new Domlet(
      this.sInputWidgetDomId,      
      this.sInputWidgetDomId,      
      this,                        
    new Array('focus')))     
  }
}
KeyEventListener.prototype.getId = function()
{
  ////;
  return this.sId;
}
KeyEventListener.prototype.setKeyboardBroker = function(broker)
{
  ////;
  this.oKeyboardBroker = broker;
}
KeyEventListener.prototype.eventFromChild = function(childName, eventType, event)
{
  ////;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "focus" :
      ;
      this.focusHandler(domlet, event);
      break;
  }
}
KeyEventListener.prototype.focusHandler = function(domlet, event)
{
  ;
  if (this.oKeyboardBroker )
  {
    this.oKeyboardBroker.doGotFocus(this.sId);
  }
  else
  {
    ;
  }
}
KeyEventListener.prototype.addChar = function(sChar)
{
  ;
  if ( this.bHasFocus && !this.inputWidget.disabled )
  {
    if (  Browser.getId() == 'moz' )
    {
      this.inputWidget.focus();
      var nSelectionStart = this.inputWidget.selectionStart;
      var nSelectionEnd = this.inputWidget.selectionEnd;
      var sCurrentText = this.inputWidget.value;
      var sText = '';
      var sNewSelection = null;
      if ( nSelectionStart != undefined)
      {
        sText = sCurrentText.substr(0,nSelectionStart);
        sText += sChar;
        sNewSelection = sText.length;
        sText += sCurrentText.substr(nSelectionEnd, sCurrentText.length);
      }
      else
      {
        sText = sChar;
        sNewSelection = sText.length;
      }
      this.inputWidget.value = sText;
      this.inputWidget.selectionStart = sNewSelection;
      this.inputWidget.selectionEnd = sNewSelection;
      if( this.bDoBlurAfterUpdate )
      {
        this.inputWidget.blur();
      }
      this.inputWidget.focus();
    }
    else
    {
      var failure = false;
      try
      {
        this.inputWidget.focus();
      }
      catch ( e )
      {
        failure = true;
      }
      if ( !failure )
      {
        if ( this.inputWidget.value )
        {
          document.selection.createRange().text = sChar;
        }
        else
        {
          this.inputWidget.value = sChar;
        }
      }
    }
  }
}
KeyEventListener.prototype.gotFocus = function(sFocusElementId)
{
  ;
  if( sFocusElementId == this.sId )
  {
    this.bHasFocus = true;
  }
  else
  {
    this.bHasFocus = false;
  }
}
KeyEventListener.prototype.getGotFocusAction = function()
{
    return new ObjectMethodAction(this, "gotFocus");
}
KeyEventListener.prototype.getAddCharAction = function(sChar)
{
    return new ObjectMethodAction(this, "addChar", sChar);
}
