/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Action</DEPENDS>
</DEPENDENCIES>
*/
function BingoManager(sId, nProlongation)
{
  if (sId) { this.init(sId, nProlongation); }
}
var gBingoManager = null; 
BingoManager.prototype.init = function(sId, nProlongation)
{
  ;
  this.sId = sId;
  this.nProlongation = nProlongation;
  this.nBingoTiles = 0;
  this.aBingoTiles = new Array();
  this.nSoundIntervals = 0;
  this.aSoundIntervals = new Array();
  this.activeInterval = null;
  this.bActive = false;
  this.soundRegistry = null;
  this.soundBroker = null;
  this.playIntervalsBeginAction = null;
  this.playIntervalsEndAction = null;
  gBingoManager = this;
}
BingoManager.prototype.start = function()
{
  ;
}
BingoManager_getInstance = function()
{
  return gBingoManager;
}
BingoManager.prototype.setSoundRegistry = function(soundRegistry)
{
  this.soundRegistry = soundRegistry;
}
BingoManager.prototype.registerSoundInterval = function(oSoundInterval)
{
  ;
  if (this.aSoundIntervals[oSoundInterval.getId()] != null)
  {
    ;
  }
  else
  {
    ;
    this.aSoundIntervals[oSoundInterval.getId()] = oSoundInterval;
    this.dragableHit = null;
    this.nSoundIntervals++;
    oSoundInterval.setManager(this);
  }
}
BingoManager.prototype.registerBingoTile = function(oBingoTile)
{
  ;
  if (this.aBingoTiles[oBingoTile.getId()] != null)
  {
    ;
  }
  else
  {
    ;
    this.aBingoTiles[oBingoTile.getId()] = oBingoTile;
    this.dragableHit = null;
    this.nBingoTiles++;
    oBingoTile.setManager(this);
  }
}
BingoManager.prototype.getNextInterval = function(lastInterval)
{
  ;
  var nextInterval = null;
  for (var id in this.aSoundIntervals)
  {
    if (lastInterval == null)
    {
      nextInterval = this.aSoundIntervals[id];
      break;
    }
    else
    {
      if (this.aSoundIntervals[id] == lastInterval) { lastInterval = null; }
    }
  }
  return nextInterval;
}
BingoManager.prototype.playNextInterval = function()
{
  ;
  this.activeInterval = this.getNextInterval(this.activeInterval);
  if (this.activeInterval)
  {
    ;
    this.activeInterval.play();
  }
  else
  {
    this.endIntervals();
    for(var tileid in this.aBingoTiles)
    {
      this.aBingoTiles[tileid].getModelItem().workItem.evaluate();
      break;
    }
  }
}
BingoManager.prototype.playedCallback = function(soundInterval)
{
  ;
  if (this.bActive)
  {
    if (soundInterval != this.activeInterval)
    {
      ;
    }
    window.setTimeout('BingoManager_getInstance().prolongatedCallback()', this.nProlongation);
  }
}
BingoManager.prototype.clickTile = function(bingoTile)
{
  ;
  if (this.activeInterval != null) {
        var eval = bingoTile.getModelItem().getEvaluation();
        if (!(eval && eval.isActive() && eval.isCorrect()))
        {
            this.activeInterval.getModelItem().assign(
             this.activeInterval.getModelItem(), bingoTile.getModelItem()
        );
    }
  }
  else
  {
  }
}
BingoManager.prototype.prolongatedCallback = function()
{
  ;
  if (this.bActive)
  {
    this.playNextInterval();
  }
}
BingoManager.prototype.startIntervals = function()
{
  ;
  if (!this.bActive)
  {
    this.bActive = true;
    this.activeInterval = null;
    if (this.playIntervalsBeginAction) this.playIntervalsBeginAction.invoke();
    this.playNextInterval();
  }
}
BingoManager.prototype.getStartIntervalsAction = function()
{
  return new ObjectMethodAction(this, 'startIntervals');
}
BingoManager.prototype.endIntervals = function()
{
  ;
  this.bActive = false;
  if (this.playIntervalsEndAction) this.playIntervalsEndAction.invoke();
}
BingoManager.prototype.getEndIntervalsAction = function()
{
  return new ObjectMethodAction(this, 'endIntervals');
}
BingoManager.prototype.setPlayIntervalsBeginAction = function(playIntervalsBeginAction)
{
  this.playIntervalsBeginAction = playIntervalsBeginAction;
}
BingoManager.prototype.setPlayIntervalsEndAction = function(playIntervalsEndAction)
{
  this.playIntervalsEndAction = playIntervalsEndAction;
}
