/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
</DEPENDENCIES>
*/
function ElementInfo(sId, id, values)
{
	this.init(sId, id, values);
}
ElementInfo.prototype.init = function(sId, id, values)
{
	var me = this;
	this.sId = sId;
	this.id = id;
	this.valueList = values;
	this.values = new Array();
	this.level = 0;
	this.mouseOverHandler = function(e)
	{
		me.manager.showElementInfo(me, e);
		return false;
	}
	this.mouseOutHandler = function(e)
	{
		me.manager.hideElementInfo(me, e);
		return false;
	}
}
ElementInfo.prototype.getId = function()
{
	return this.sId;
}
ElementInfo.prototype.addValue = function(value)
{
	this.valueList.push(value);
}
ElementInfo.prototype.resolve = function(pageDocument)
{
	this.id.resolve(pageDocument);
	for (var i = 0; i < this.valueList.length; i++)
	{
		var value = this.valueList[i];
		this.values[value.getProperty()] = value.getValue();
	}
}
ElementInfo.prototype.register = function(manager, markerDIV)
{
	this.manager = manager;
	this.markerDIV = markerDIV;
	Browser.addEventListenerToDomNode(markerDIV, Browser.eventNames.MOUSEOVER, this.mouseOverHandler);
	Browser.addEventListenerToDomNode(markerDIV, Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
}
ElementInfo.prototype.unregister = function(parent)
{
	this.manager = null;
	parent.removeChild(this.markerDIV);
	this.markerDIV = null;
	Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEOVER, this.mouseOverHandler);
	Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
}
ElementInfo.prototype.exists = function()
{
	return this.id.exists();
}
ElementInfo.prototype.getLevel = function()
{
	return this.id.getLevel();
}
ElementInfo.prototype.getPosition = function()
{
	return this.id.getPosition();
}
ElementInfo.prototype.getWidth = function()
{
	return this.id.getWidth();
}
ElementInfo.prototype.getHeight = function()
{
	return this.id.getHeight();
}
ElementInfo.prototype.getValue = function(property)
{
	var value = this.values[property];
	if (value == undefined)
		value = null;
	return value;
}
