/*
<DEPENDENCIES>
  <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function SimpleDropTarget( sId, sWidgetDomId )
{
  if( sId )
  {
    this.init(sId, sWidgetDomId);
  }
}
SimpleDropTarget.prototype.init = function(sId, sWidgetDomId)
{
  this.sId = sId;
  this.sWidgetDomId = sWidgetDomId;
  this.nWidget = document.getElementById(sWidgetDomId);
  this.broker = null;
  this.dragnDropManager = null;
  this.itemManager = null;
  this.homePos = null;
  this.showOverAction = null;
  this.showOutAction = null;
}
SimpleDropTarget.prototype.getId = function()
{
  return this.sId;
}
SimpleDropTarget.prototype.setItemManager = function( itemManager )
{
  this.itemManager = itemManager;
}
SimpleDropTarget.prototype.getItemManager = function()
{
  return this.itemManager;
}
SimpleDropTarget.prototype.setManager = function( dragnDropManager )
{
  this.dragnDropManager = dragnDropManager;
}
SimpleDropTarget.prototype.hitTest = function( oDragable, nX, nY )
{
  var widgetPos = new Point(0, 0);
  Browser.getAbsPos(this.nWidget, widgetPos);
  var left = widgetPos.x;
  var top = widgetPos.y;
  var right = widgetPos.x + this.nWidget.offsetWidth;
  var bottom = widgetPos.y + this.nWidget.offsetHeight;
  if( left < nX && nX < right && top < nY && nY < bottom )
  {
    return true;
  }
  else
  {
    return false;
  }
}
SimpleDropTarget.prototype.setBroker = function( broker )
{
  this.broker = broker;
}
SimpleDropTarget.prototype.changed = function( model )
{
}
SimpleDropTarget.prototype.notifyItemChange = function( model, item )
{
}
SimpleDropTarget.prototype.enter = function( oDragable )
{
  if( this.broker )
    this.broker.showOver();
  oDragable.enter(this);
}
SimpleDropTarget.prototype.leave = function( oDragable )
{
  if( this.broker )
    this.broker.showOut();
  oDragable.leave(this);
}
SimpleDropTarget.prototype.drop = function( oDragable )
{
  var bDropped = false;
  if( this.itemManager )
  {
    if( this.itemManager.isInScope(oDragable.getModelItem()) )
    {
      var item = oDragable.getModelItem();
      oDragable.setModelItem(null);
      this.itemManager.assign(item, oDragable.dropPos.x, oDragable.dropPos.y);
      bDropped = true;
    }
  }
  else
  {
    bDropped = true;
  }
  oDragable.drop(this, bDropped);
}
SimpleDropTarget.prototype.lift = function( oDragable )
{
}
