/*
<DEPENDENCIES>
  <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function ToolbarPaletteManager( sId )
{
  if( sId )
  {
    this.init(sId);
  }
}
ToolbarPaletteManager.prototype.init = function( sId, bEnabled, bHighlighted )
{
  ;
  this.sId = sId;
  this.state = {
    enabled : ((bEnabled == undefined) ? true : bEnabled),
    highlighted : ((bHighlighted == undefined)
            ? false
            : ((bEnabled != undefined && bEnabled == false) ? false : bHighlighted))
  };
  this.aEnabledHandles = new Array();
  this.aDisabledHandles = new Array();
  this.aHighlightHandles = new Array();
}
ToolbarPaletteManager.prototype.getId = function()
{
  return this.sId;
}
ToolbarPaletteManager.prototype.start = function()
{
  if( this.state.highlighted )
    ToolbarPaletteManager.notifyListeners(this.aHighlightHandles);
  else if( this.state.enabled )
    ToolbarPaletteManager.notifyListeners(this.aEnabledHandles);
  else
    ToolbarPaletteManager.notifyListeners(this.aDisabledHandles);
}
ToolbarPaletteManager.prototype.enable = function()
{
  this.state.enabled = true;
  this.state.highlighted = false;
  ToolbarPaletteManager.notifyListeners(this.aEnabledHandles);
}
ToolbarPaletteManager.prototype.getEnableAction = function()
{
  return new ObjectMethodAction(this, "enable");
}
ToolbarPaletteManager.prototype.addEnabledHandle = function( action )
{
  if( action )
    this.aEnabledHandles.push(action);
}
ToolbarPaletteManager.prototype.isEnabled = function()
{
  return this.state.enabled;
}
ToolbarPaletteManager.prototype.disable = function()
{
  this.state.enabled = false;
  this.state.highlighted = false;
  ToolbarPaletteManager.notifyListeners(this.aDisabledHandles);
}
ToolbarPaletteManager.prototype.getDisableAction = function()
{
  return new ObjectMethodAction(this, "disable");
}
ToolbarPaletteManager.prototype.addDisabledHandle = function( action )
{
  if( action )
    this.aDisabledHandles.push(action);
}
ToolbarPaletteManager.prototype.isDisabled = function()
{
  return !this.state.enabled;
}
ToolbarPaletteManager.prototype.highlight = function()
{
  this.state.enabled = true;
  this.state.highlighted = true;
  ToolbarPaletteManager.notifyListeners(this.aHighlightHandles);
}
ToolbarPaletteManager.prototype.getHighlightAction = function()
{
  return new ObjectMethodAction(this, "highlight");
}
ToolbarPaletteManager.prototype.addHighlightHandle = function( action )
{
  if( action )
    this.aHighlightHandles.push(action);
}
ToolbarPaletteManager.prototype.isHighligted = function()
{
  return this.state.highlighted;
}
ToolbarPaletteManager.notifyListeners = function( handles )
{
  for( var i = 0; i < handles.length; i++ )
  {
    handles[i].invoke();
  }
}
