/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Point</DEPENDS>
    <DEPENDS>ObjectMethodAction</DEPENDS>
</DEPENDENCIES>
*/
function DominoManager(sId,sWidgetBoundingBox,dominoItemPadding)
{
  if (sId) { this.init(sId,sWidgetBoundingBox,dominoItemPadding); }
}
DominoManager.prototype.init = function(sId,sWidgetBoundingBox,dominoItemPadding)
{
  ;
  this.widgetBoundingBox = document.getElementById(sWidgetBoundingBox);
  this.sWidgetBoundingBox = sWidgetBoundingBox;
  if (this.widgetBoundingBox == null)
  {
    ;
  }
  this.bLastVerticalIsBelow = null;
  this.sId = sId;
  this.aContainerDominoItems = new Array();
  this.aContainerDominoItemsSorter = new Array();
  this.aDominoItems = new Array();
  this.bContainerDominoItemReverse = false;
  this.nSetToplevelCnt = null;
  this.dominoItemPadding = null;
  if(dominoItemPadding)
  {
    this.dominoItemPadding = dominoItemPadding;    
  }
  this.maxWidth = Browser.getPixelStyle(this.widgetBoundingBox, 'width');
  this.containerStartPoint = new Point(0,0);
  this.nAbsPosOfDominoItemBoundingBox = new Point(0,0);
  Browser.getAbsPos(this.widgetBoundingBox, this.containerStartPoint);
  Browser.getAbsPos(this.widgetBoundingBox, this.nAbsPosOfDominoItemBoundingBox);
  this.containerStartPoint.x += parseInt(this.widgetBoundingBox.style.width) ;
  this.containerStartPoint.y += parseInt(this.widgetBoundingBox.style.height);
  this.actualContainerPoint = new Point(0,0);
  this.aActiveDominoItems = new Array();
}
DominoManager.prototype.start = function()
{
  ;    
  this.aDominoItems =  this.aContainerDominoItems;
  shuffleArray(this.aContainerDominoItems);
  this.aContainerDominoItemsSorter = this.aContainerDominoItems;
  var ActiveDominoItem = this.aContainerDominoItems.shift();
  var answer = ActiveDominoItem.modelItem;
  var question = ActiveDominoItem.modelItem.getSolutionComplement();
  ActiveDominoItem.modelItem.workItem.getEvaluation(question,answer).setActive(true,'system_off');
}
DominoManager.prototype.registerDominoItem = function(oDominoItem)
{
  ;
  var alreadyInArray = null;
  for(var i in this.aContainerDominoItems)
  {
    if(this.aContainerDominoItems[i] == oDominoItem)
    {
      ;  
      alreadyInArray = true;
    }
  }
  this.setPosOfContainerItem(oDominoItem);
  if(!alreadyInArray)
  {
    ;
    this.aContainerDominoItems[this.aContainerDominoItems.length] = oDominoItem;
    oDominoItem.setManager(this);
  }
}
DominoManager.prototype.addDominoItemToContainer = function(oDominoItem)
{
  ;
  var alreadyInArray = null;
  for(var i in this.aContainerDominoItems)
  {
    if(this.aContainerDominoItems[i] == oDominoItem)
    {
      ;  
      alreadyInArray = true;
    }
  }
  if(!alreadyInArray)
  {
    ;
    this.aContainerDominoItems[this.aContainerDominoItems.length] = oDominoItem;
  }
  this.aContainerDominoItems = this.sortArrayByArray(this.aContainerDominoItems, this.aContainerDominoItemsSorter);
  this.resetPosOfContainerItems();
}
DominoManager.prototype.setPosOfContainerItem = function(oDominoItem)
{
  ;
  if (this.bContainerDominoItemReverse)
  {
    oDominoItem.setBackwards(true);
  }
  else
  {
    oDominoItem.setBackwards(false);
  }
  oDominoItem.setVertical(false);
  var actualContainerPoint = new Point();
  var lastDominoItem = this.aContainerDominoItems[this.aContainerDominoItems.length - 1];
  if(!oDominoItem)
  {
    ;
  }
  else
  {
    if(this.aContainerDominoItems.length == 0)
    {
      actualContainerPoint.x = this.containerStartPoint.x - oDominoItem.dominoItemWidth;
      actualContainerPoint.y = this.containerStartPoint.y - oDominoItem.dominoItemHeight;
    }
    else
    {
      if(lastDominoItem.homePos.x - oDominoItem.dominoItemWidth - this.dominoItemPadding - this.nAbsPosOfDominoItemBoundingBox.x> 0)
      {
        actualContainerPoint.x = lastDominoItem.homePos.x - oDominoItem.dominoItemWidth - this.dominoItemPadding; 
        actualContainerPoint.y = lastDominoItem.homePos.y;
      }
      else
      {
        actualContainerPoint.x = this.containerStartPoint.x - oDominoItem.dominoItemWidth;
        actualContainerPoint.y = lastDominoItem.homePos.y - oDominoItem.dominoItemHeight - this.dominoItemPadding;
      }
    }    
    oDominoItem.setHomePos(new Point(actualContainerPoint.x,actualContainerPoint.y));
    oDominoItem.moveToHomePosition();
  }
}
DominoManager.prototype.resetPosOfContainerItems = function ()
{
  aContainer = new Array();
  aContainer = this.aContainerDominoItems;
  this.aContainerDominoItems = new Array();
  for(var i in aContainer)
  {
    this.setPosOfContainerItem(aContainer[i]);
    this.aContainerDominoItems[i] = aContainer[i]
  }
}
DominoManager.prototype.getDominoItemSnapPoint = function(oDominoItem)
{
  oDominoItem.setVertical(false);
  oDominoItem.setBackwards(false);
  var aArray = new Array()
  var dominoItemSnapPoint = new Point(0,0)
  if ( this.aActiveDominoItems.length == 0 )
  {
    Browser.getAbsPos(this.widgetBoundingBox , dominoItemSnapPoint);
  }
  else
  {
    if ( ! this.aActiveDominoItems[this.aActiveDominoItems.length-1].bIsBackwards )
    { 
      if ( ! this.aActiveDominoItems[this.aActiveDominoItems.length-1].bIsVertical )
      {
        if ((this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemWidth + oDominoItem.dominoItemWidth + this.dominoItemPadding ) < this.maxWidth + this.nAbsPosOfDominoItemBoundingBox.x)
        {
          dominoItemSnapPoint.x = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemWidth + this.dominoItemPadding;
          dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y;
        }
        else
        {  
          oDominoItem.setVertical(true);
          oDominoItem.setBackwards(false);
          this.bContainerDominoItemReverse = true;
          if (((this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemWidth + oDominoItem.dominoItemWidth + this.dominoItemPadding ) < this.maxWidth + this.nAbsPosOfDominoItemBoundingBox.x))
          {
            dominoItemSnapPoint.x = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemWidth + this.dominoItemPadding;
            dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y;
            this.bLastVerticalIsBelow = false;
          }
          else
          {
            dominoItemSnapPoint.x = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemWidth - oDominoItem.dominoItemWidth;
            dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemHeight + this.dominoItemPadding;
            this.bLastVerticalIsBelow = true;
          }
        }
      }
      else
      {
        if (( this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemWidth + this.dominoItemPadding + oDominoItem.dominoItemWidth  ) < this.maxWidth + this.nAbsPosOfDominoItemBoundingBox.x)
        { 
          if ( this.bLastVerticalIsBelow )
          {
            dominoItemSnapPoint.x = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x + this.dominoItemPadding + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemWidth;
            dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y + oDominoItem.dominoItemHeight;       
          }
          else
          {            
            dominoItemSnapPoint.x = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x;
            dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemHeight + this.dominoItemPadding;
          }          
        }
        else
        {
          oDominoItem.setBackwards(true);
          if ( this.bLastVerticalIsBelow )
          {
            dominoItemSnapPoint.x = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x - this.dominoItemPadding - oDominoItem.dominoItemWidth;
            dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y + oDominoItem.dominoItemHeight;       
          }
          else
          {
            dominoItemSnapPoint.x = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemWidth - oDominoItem.dominoItemWidth;
            dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y + this.aActiveDominoItems[this.aActiveDominoItems.length-1].dominoItemHeight + this.dominoItemPadding;
          }
        }
      }
    }
    else
    {      
      if (( this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x  - this.dominoItemPadding - oDominoItem.dominoItemWidth - this.nAbsPosOfDominoItemBoundingBox.x ) > 0)
      {
        if ( ! this.aActiveDominoItems[this.aActiveDominoItems.length-1].bIsVertical )
        {
          oDominoItem.setBackwards(true);
          dominoItemSnapPoint.x = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x - this.dominoItemPadding - oDominoItem.dominoItemWidth;
          dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y;
        }
        else
        {
        }
      }
      else
      {
        this.bContainerDominoItemReverse = false;
        oDominoItem.setVertical(true);
        oDominoItem.setBackwards(false);
        if((this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x - this.dominoItemPadding - oDominoItem.dominoItemWidth  - this.nAbsPosOfDominoItemBoundingBox.x ) > 0)
        {
          dominoItemSnapPoint.x = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.x - this.dominoItemPadding - oDominoItem.dominoItemWidth;
          dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y;
          this.bLastVerticalIsBelow = true;          
        }
        else
        {
          dominoItemSnapPoint.y = this.aActiveDominoItems[this.aActiveDominoItems.length-1].homePos.y;
          dominoItemSnapPoint.x = this.nAbsPosOfDominoItemBoundingBox.x;
          this.bLastVerticalIsBelow = false;        
        }
      }
    }
  }  
  this.aActiveDominoItems.push(oDominoItem);  
  for(var i in this.aContainerDominoItems)
  {
   if ( this.aContainerDominoItems[i] != oDominoItem)
    {
      aArray.push(this.aContainerDominoItems[i]);
    }
  }
  this.aContainerDominoItems = aArray;
  this.resetPosOfContainerItems();
  return dominoItemSnapPoint;
}
DominoManager.prototype.click = function(oDominoItem)
{
  if(this.aActiveDominoItems[this.aActiveDominoItems.length-1].oAppendantQuestion.getSolutionComplement() == oDominoItem.modelItem)
  {
    var answer = oDominoItem.modelItem;
    var question = oDominoItem.modelItem.getSolutionComplement();   
    oDominoItem.modelItem.workItem.getEvaluation(question,answer).setActive(true,'user');
  }    
}
DominoManager.prototype.setToplevel = function(oDominoItem)
{
  ;
  if (this.nSetToplevelCnt == 0) {
    this.nSetToplevelCnt = document.all.length;
  }
  this.nSetToplevelCnt++;
  oDominoItem.dragWidget.style.zIndex = this.nSetToplevelCnt;
}
DominoManager.prototype.beginDrag = function(oDominoItem)
{
  ;
} 
DominoManager.prototype.endDrag = function(oDominoItem)
{
  ;
} 
DominoManager.prototype.drag = function(oDominoItem, nX, nY)
{
  ;
} 
DominoManager.prototype.sortArrayByArray = function(aArray, aSortByArray)
{
  var aTempArray = new Array();
  for( var i in aSortByArray)
  {
    for( var s in aArray )
    {
      if( aArray[s] == aSortByArray[i])
      {
        aTempArray[aTempArray.length] = aArray[s];
      }
    }
  }
  return aTempArray;
}
DominoManager.prototype.reset = function()
{
   for ( var i in this.aDominoItems )
   {
     this.aDominoItems[i].setBackwards(false);
     this.aDominoItems[i].setVertical(false);
   }
}
DominoManager.prototype.getResetAction = function()
{
  return new ObjectMethodAction(this, 'reset');
}
