/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ObjectMethodAction</DEPENDS>
</DEPENDENCIES>
*/
function Point(x, y)
{
	this.x = x;
	this.y = y;
}
function DragnDropManager(sId)
{
	this.init(sId)
}
DragnDropManager.prototype.init = function(sId)
{
	;
	this.sId = sId;
	this.nDragables = 0;
	this.aDragables = new Array();
	this.nDropTargets = 0;
	this.aDropTargets = new Array();
	this.dragableHit = null;
	
	this.dragStartedHandles = new Array();
}
DragnDropManager.prototype.getId = function()
{
	return this.sId;
}
DragnDropManager.prototype.registerDragable = function(oDragable)
{
	;
	if (this.aDragables[oDragable.getId()] != null)
	{
		;
	}
	else
	{
		;
		this.aDragables[oDragable.getId()] = oDragable;
		this.dragableHit = null;
		this.nDragables++;
		oDragable.setManager(this);
	}
}
DragnDropManager.prototype.registerDropTarget = function(oDropTarget)
{
	;
	if (this.aDropTargets[oDropTarget.getId()] != null)
	{
		;
	}
	else
	{
		;
		this.aDropTargets[oDropTarget.getId()] = oDropTarget;
		this.nDropTargets++;
		oDropTarget.setManager(this);
	}
}
DragnDropManager.prototype.registerDragStartedHandle = function(action)
{
	;
	this.dragStartedHandles.push(action);
}
DragnDropManager.prototype.fireDragStarted = function()
{
	;
	for (var i = 0; i < this.dragStartedHandles.length; i++)
	{
		 this.dragStartedHandles[i].invoke();
	}
}
DragnDropManager.prototype.start = function()
{
	;
}
DragnDropManager.prototype.beginDrag = function(oDragable)
{
	this.fireDragStarted();
	if (oDragable.isDropped())
	{
		oDragable.getDropTarget().lift(oDragable);
	}
}
DragnDropManager.prototype.endDrag = function(oDragable)
{
	;
	if (oDragable.endDragAction) oDragable.endDragAction.invoke();
	var dropTarget = this.dragableHit;
	if (dropTarget)
	{
		;
		dropTarget.leave(oDragable);
		this.dragableHit = null;
		dropTarget.drop(oDragable);
	}
}
DragnDropManager.prototype.drag = function(oDragable, nX, nY)
{
	//;
	for (var id in this.aDropTargets)
	{
		var dropTarget = this.aDropTargets[id];
		//;
		if (dropTarget.hitTest(oDragable, nX, nY))
		{
			//;
			if (!(this.dragableHit == dropTarget))
			{
				;
				if (this.dragableHit != null)
				{
					this.dragableHit.leave(oDragable);
					this.dragableHit = null;
				}
				this.dragableHit = dropTarget;
				dropTarget.enter(oDragable);
			}
		}
		else
		{
			if (this.dragableHit == dropTarget)
			{
				;
				dropTarget.leave(oDragable);
				this.dragableHit = null;
			}
		}
	}
}
DragnDropManager.prototype.getDropTargetByModelId = function(sModelId)
{
	;
	var dropTarget = null;
	for (var id in this.aDropTargets)
	{
		if (this.aDropTargets[id].getModelId() == sModelId)
		{
			dropTarget = this.aDropTargets[id];
			break;
		}
	}
	return dropTarget;
}
DragnDropManager.prototype.getDropTargetByModel = function(model)
{
	;
	var dropTarget = null;
	for (var id in this.aDropTargets)
	{
		if (this.aDropTargets[id].getModelItem() == model)
		{
			dropTarget = this.aDropTargets[id];
			break;
		}
	}
	return dropTarget;
}
DragnDropManager.prototype.getDragableByModel = function(model)
{
	;
	var dragable = null;
	for (var id in this.aDragables)
	{
		if (this.aDragables[id].getModelItem() == model)
		{
			dragable = this.aDragables[id];
			break;
		}
	}
	return dragable;
}
DragnDropManager.prototype.reset = function()
{
	
}
DragnDropManager.prototype.getResetAction = function()
{
	return new ObjectMethodAction(this, "reset");
}
