/*
<DEPENDENCIES>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>PointInAreaTest</DEPENDS>
</DEPENDENCIES>
*/
function DropTarget(sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY)
{
  if (sId) { this.init(sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY); }
}
DropTarget.prototype.init = function(sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY)
{
  ;
  this.sId = sId;
  this.dropWidget = document.getElementById(sWidgetDomId);
  this.sWidgetDomId = sWidgetDomId;
  this.dragnDropManager = null;
  this.sAreaDomId = sAreaDomId;
  this.nSnapX = nSnapX; 
  this.nSnapY = nSnapY; 
  this.homePos = null;
  this.showOverAction = null;
  this.showOutAction = null;
  this.snapStrategy = null;
  this.eArea = Browser.getElementById(sAreaDomId);
}
DropTarget.prototype.initArea = function()
{
  if ( ! this.homePos )
  {
    this.homePos = this.getPos()
    if (this.dropWidget.style.position != 'absolute')
    {
      this.homePos.x += 1;
      this.homePos.y += 1;
    }
  }
  this.area = new PointInAreaTest(this.eArea);
  if (this.area == null)
  {
    ;
  }
  else
  {
    ;
  }
  if (this.dropWidget == null)
  {
    ;
  }
}
DropTarget.prototype.getId = function()
{
  return this.sId;
}
DropTarget.prototype.start = function()
{
  ;
}
DropTarget.prototype.getPos = function()
{
  //;
  var point = new Point(0,0);
  Browser.getAbsPos(this.dropWidget, point);
  return point;
}
DropTarget.prototype.setValueItem = function(valueItem)
{
  ;
  this.valueItem = valueItem;
}
DropTarget.prototype.registerSnapStrategy = function(snapStrategy)
{
  ;
  this.snapStrategy = snapStrategy;
  this.snapStrategy.setDropTarget(this);
}
DropTarget.prototype.setManager = function(dragnDropManager)
{
  ;
  this.dragnDropManager = dragnDropManager;
}
DropTarget.prototype.hitTest = function(oDragable, nX, nY)
{
  //;
  if (this.area == undefined) this.initArea();
  var bHit = false;
  var point = new Point(0,0);
  Browser.getScrollPos(this.dropWidget, point);
  //;
  var nRelX = nX - this.homePos.x + point.x;
  var nRelY = nY - this.homePos.y + point.y;
  //;
  bHit = this.area.pointInside( [nRelX,nRelY] );
  if (bHit)
  {
    bHit = true;
    //;
  }
  return bHit;
}
DropTarget.prototype.enter = function(oDragable)
{
  ;
  oDragable.enter(this);
}
DropTarget.prototype.leave = function(oDragable)
{
  ;
  oDragable.leave(this);
}
DropTarget.prototype.drop = function(oDragable)
{
  ;
  var bDropped = true;
  oDragable.drop(this, bDropped);
}
DropTarget.prototype.lift = function(oDragable)
{
  ;
  oDragable.lift(this);
}
DropTarget.prototype.snap = function(dragable)
{
  ;
  var token = null;
  if ( ! this.homePos )
  {
    this.homePos = this.getPos()
    if (this.dropWidget.style.position != 'absolute')
    {
      this.homePos.x += 1;
      this.homePos.y += 1;
    }
  }
  if (this.snapStrategy)
  {
    this.snapStrategy.snap(dragable);
  }
  else
  {
    dragable.moveToSnapPosition(new Point(this.nSnapX+ this.homePos.x, this.nSnapY + this.homePos.y));
  }
}
DropTarget.prototype.getModelId = function()
{
  //;
  return this.valueItem.getId();
}
DropTarget.prototype.getValueItem= function()
{
  //;
  return this.valueItem;
}
DropTarget.prototype.setShowOverAction = function(action)
{
  ;
  this.showOverAction = action;
}
DropTarget.prototype.setShowOutAction = function(action)
{
  ;
  this.showOutAction = action;
}
  function PointInAreaTest(area_elem)
  {
    this.shape = '';
    this.coords = '';
    this.target = '';
    if (area_elem != null)
    {
      this.shape = area_elem.shape;
      this.domId = area_elem.id;
      if (this.shape == 'poly' || this.shape == 'POLY')
      {
        this.poly = new Array();
        var data = area_elem.coords.split(',');
        var data_idx = 0;
        var point_idx = 0;
        while (data_idx < data.length)
        {
          this.coords += '('+data[data_idx]+'/'+data[data_idx+1]+') ';
          this.poly[point_idx] = [ data[data_idx] , data[data_idx+1] ];
          point_idx++;
          data_idx += 2;
        }
      }
    }
  }
  PointInAreaTest.prototype.oneDimIntersect = function(p1, q1, p2, q2)
  {
    return ! (
           (p1 < p2 && p1 < q2 && q1 < p2 && q1 < q2)
        || (p1 > p2 && p1 > q2 && q1 > p2 && q1 > q2) );
  }
  PointInAreaTest.prototype.signOfCrossProduct = function(p1, p2, p3)
  {
    var x21 = p2[0] - p1[0];
    var y21 = p2[1] - p1[1];
    var x32 = p3[0] - p2[0];
    var y32 = p3[1] - p2[1];
    p = (y21*x32) - (y32*x21);
    var s = 0;
    if (p < 0) s = -1;
    else if (p > 0) s = 1;
    return s;
  }
  PointInAreaTest.prototype.segmentsIntersect = function(p1, q1, p2, q2)
  {
    var p1q1p2 = this.signOfCrossProduct(p1, q1, p2);
    var p1q1q2 = this.signOfCrossProduct(p1, q1, q2);
    var p2q2p1 = this.signOfCrossProduct(p2, q2, p1);
    var p2q2q1 = this.signOfCrossProduct(p2, q2, q1);
    var c = (p1q1p2 != p1q1q2 && p2q2p1 != p2q2q1);
    if (!c) {
      if (p1q1p2 == 0 &&
          p1q1q2 == 0 &&
          p2q2p1 == 0 &&
          p2q2q1 == 0) {
        c = this.oneDimIntersect(p1[0], q1[0], p2[0], q2[0]) && this.oneDimIntersect(p1[1], q1[1], p2[1], q2[1]);
      }
    }
    return c;
  }
  PointInAreaTest.prototype.rayCrossesPolygon = function(point, poly)
  {
    var crossings = 0;
    var max = 0;
    var i = 0;
    for (i = 0; i < poly.length; i++) {
      if (max < poly[i][0]) max = poly[i][0];
      if (max < poly[i][1]) max = poly[i][1];
    }
    var outside = [ max + 1 , max + Math.PI ];
    for (i = 0; i < poly.length-1; i++) {
      if (this.segmentsIntersect(point, outside, poly[i], poly[i+1])) {
        crossings++;
      }
    }
    if (this.segmentsIntersect(point, outside, poly[poly.length-1], poly[0])) {
      crossings++;
    }
    return crossings;
  }
  PointInAreaTest.prototype.pointInsidePolygon = function(point, poly)
  {
    return (this.rayCrossesPolygon(point, poly) % 2 == 1);
  }
  PointInAreaTest.prototype.pointInside = function(point)
  {
    if (this.shape == 'poly' || this.shape == 'POLY')
    {
      return this.pointInsidePolygon(point, this.poly);
    }
  }
  PointInAreaTest.prototype.centerPointPolygon = function(poly)
  {
    var x = 0;
    var y = 0;
    for (i = 0; i < poly.length; i++) {
      x = parseInt(x) + parseInt(poly[i][0]);
      y = parseInt(y) + parseInt(poly[i][1]);
    }
    return [ parseInt(x/poly.length), parseInt(y/poly.length) ];
  }
  PointInAreaTest.prototype.centerPoint = function()
  {
    if (this.shape == 'poly' || this.shape == 'POLY')
    {
      return this.centerPointPolygon(this.poly);
    }
  }
  PointInAreaTest.prototype.test = function()
  {
    var poly = new Array();
    var j = 0;
    poly[j++] = [ 0, 0 ];
    poly[j++] = [ 10, 10 ];
    poly[j++] = [ 10, 0 ];
    alert(0 == rayCrossesPolygon([ 0, 10 ], poly));
    alert(1 == rayCrossesPolygon([ 5, 5 ], poly));
    alert(1 == rayCrossesPolygon([ 2, 1 ], poly));
    alert(1 == rayCrossesPolygon([ 9, 1 ], poly));
    alert(0 == rayCrossesPolygon([ 11, 1 ], poly));
    alert(2 == rayCrossesPolygon([ 9, -1 ], poly));
    alert(2 == rayCrossesPolygon([ 0, -1 ], poly));
    alert(0 == rayCrossesPolygon([ -1, -1 ], poly));
  }
