/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
DataModelViewBroker.prototype = new Broker();
DataModelViewBroker.prototype.constructor = DataModelViewBroker;
DataModelViewBroker.superclass = Broker.prototype;
function DataModelViewBroker(sId)
{
	this.init(sId);
}
DataModelViewBroker.prototype.init = function(sId)
{
	this.sId = sId;
	DataModelViewBroker.superclass.init.call(this, sId);
}
DataModelViewBroker.prototype.getId = function()
{
	return this.sId;
}
DataModelViewBroker.prototype.getNextElementsAction = function()
{
	return new ObjectMethodAction(this, "nextElements");
}
DataModelViewBroker.prototype.addNextElementsHandle = function(action)
{
	this.registerAction("nextElements", action);
}
DataModelViewBroker.prototype.nextElements = function(numberOfElements)
{
	var params = new Array();
	params[0] = numberOfElements;
	this.getMessage("nextElements", params);
}
DataModelViewBroker.prototype.getPreviousElementsAction = function()
{
	return new ObjectMethodAction(this, "previousElements");
}
DataModelViewBroker.prototype.addPreviousElementsHandle = function(action)
{
	this.registerAction("previousElements", action);
}
DataModelViewBroker.prototype.previousElements = function(numberOfElements)
{
	var params = new Array();
	params[0] = numberOfElements;
	this.getMessage("previousElements", params);
}
DataModelViewBroker.prototype.addDataChangedHandle = function(action)
{
	this.registerAction("datachanged", action);
}
DataModelViewBroker.prototype.dataChanged = function(totalNumberOfElements, startIndex, endIndex)
{
	var params = new Array();
	params[0] = totalNumberOfElements;
	params[1] = startIndex;
	params[2] = endIndex;
	this.getMessage("datachanged", params);
}
