/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
ModelViewBroker.prototype = new Broker();
ModelViewBroker.prototype.constructor = ModelViewBroker;
ModelViewBroker.superclass = Broker.prototype;
function ModelViewBroker( sId )
{
  this.init(sId);
}
ModelViewBroker.prototype.init = function( sId )
{
  this.sId = sId;
  ModelViewBroker.superclass.init.call(this, sId);
}
ModelViewBroker.prototype.getId = function()
{
  return this.sId;
}
ModelViewBroker.prototype.getModelChangedAction = function()
{
  return new ObjectMethodAction(this, "modelChanged");
}
ModelViewBroker.prototype.addModelChangedHandle = function( action )
{
  this.registerAction("modelChanged", action);
}
ModelViewBroker.prototype.modelChanged = function( numberOfEntries, startIndex, stopIndex )
{
  var params = new Array();
  params[0] = numberOfEntries;
  params[1] = startIndex;
  params[2] = stopIndex;
  this.getMessage("modelChanged", params);
}
ModelViewBroker.prototype.addShiftDownHandle = function( action )
{
  this.registerAction("shiftDown", action);
}
ModelViewBroker.prototype.shiftDown = function( numberOfElements )
{
  var elementsArray = new Array();
  elementsArray[0] = numberOfElements;
  this.getMessage("shiftDown", elementsArray);
}
ModelViewBroker.prototype.addShiftUpHandle = function( action )
{
  this.registerAction("shiftUp", action);
}
ModelViewBroker.prototype.shiftUp = function( numberOfElements )
{
  var elementsArray = new Array();
  elementsArray[0] = numberOfElements;
  this.getMessage("shiftUp", elementsArray);
}
