/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function DynamicDataLoader(screenbroker, channel, category, deepLinkTarget, deeplinkFromProduct)
{
	this.screenbroker = screenbroker;
	var baseparams = "?channel=" + channel + "&category=" + category;
	this.idloaderurl = "../idloader" + baseparams;
	this.infoloaderurl = "../infoloader" + baseparams;
	this.dataloaderurl = "../dataloader" + baseparams;
	this.filterloaderurl = "../productfilter" + baseparams;
	this.filterloaderurl = "../productfilter" + baseparams;
	this.deeplinkurl = "../deeplink" + baseparams;
	this.deepLinkTarget = deepLinkTarget;
	this.deeplinkFromProduct = (deeplinkFromProduct == true);
	this.callbacks = new Array();
	this.filtercallbacks = new Array();
	DynamicDataLoader.instance = this;
}
DynamicDataLoader.PARAM_TARGETJSID = "targetjsid";
DynamicDataLoader.PARAM_PRODUCTID = "id";
DynamicDataLoader.PARAM_STARTINDEX = "from";
DynamicDataLoader.PARAM_ENDINDEX = "to";
DynamicDataLoader.prototype.loadFilterData = function(callback, manager, command)
{
	var filterurl = this.filterloaderurl;
	filterurl += "&";
	filterurl += DynamicDataLoader.PARAM_TARGETJSID + "=";
	filterurl += encodeURIComponent(callback.getId());
	filterurl += command;
	;
	this.filtercallbacks[callback.getId()] = callback;
	var innerCallback = new DynamicDataLoaderCallback(callback.getId(), filterurl);
	callback.started();
	Browser.loadDocument(filterurl, innerCallback.getLoadedAction(), innerCallback.getErrorAction());
}
DynamicDataLoader.prototype.filterDataLoaded = function(targetid, data)
{
	;
	var callback = this.filtercallbacks[targetid];
	if (callback)
	{
		callback.dataLoaded(data);
	}
}
DynamicDataLoader.prototype.filterDataLoadedCommit = function(targetid)
{
	;
	var callback = this.filtercallbacks[targetid];
	if (callback)
	{
		callback.commit();
	}
}
DynamicDataLoader.prototype.loadProductData = function(callback, productid)
{
	var producturl = this.dataloaderurl;
	producturl += "&";
	producturl += DynamicDataLoader.PARAM_TARGETJSID + "=";
	producturl += encodeURIComponent(callback.getId());
	producturl += "&";
	producturl += DynamicDataLoader.PARAM_PRODUCTID + "=";
	producturl += encodeURIComponent(productid);
	this.callbacks[callback.getId()] = callback;
	var innerCallback = new DynamicDataLoaderCallback(callback.getId(), producturl);
	Browser.loadDocument(producturl, innerCallback.getLoadedAction(), innerCallback.getErrorAction());
}
DynamicDataLoader.prototype.dataLoaded = function(targetid, data)
{
	var callback = this.callbacks[targetid];
	;
	if (callback)
	{
		callback.dataLoaded(data);
	}
}
DynamicDataLoader.prototype.dataLoadedCommit = function(targetid)
{
	var callback = this.callbacks[targetid];
	;
	if (callback)
	{
		callback.commit();
	}
}
DynamicDataLoader.prototype.loadProductInfos = function(callback, manager, productIds)
{
	var producturl = this.infoloaderurl;
	producturl += "&";
	producturl += DynamicDataLoader.PARAM_TARGETJSID + "=";
	producturl += encodeURIComponent(callback.getId());
	for (var i in productIds)
	{
		producturl += "&";
		producturl += DynamicDataLoader.PARAM_PRODUCTID + "=";
		producturl += productIds[i];
	}
	;
	this.callbacks[callback.getId()] = callback;
	var innerCallback = new DynamicDataLoaderCallback(callback.getId(), producturl);
	Browser.loadDocument(producturl, innerCallback.getLoadedAction(), innerCallback.getErrorAction());
}
DynamicDataLoader.prototype.productInfosLoaded = function(targetid, data)
{
	;
	var callback = this.callbacks[targetid];
	if (callback)
	{
		callback.productInfosLoaded(data);
	}
}
DynamicDataLoader.prototype.productInfosLoadedCommit = function(targetid)
{
	;
	var callback = this.callbacks[targetid];
	if (callback)
	{
		callback.commit();
	}
}
DynamicDataLoader.prototype.parseDocument = function (xmldoc)
{
	var javascript = xmldoc.getElementsByTagName('javascript');
	for (var i = 0; i < javascript.length; i++)
	{
		;
		for (var j = 0; j < javascript[i].childNodes.length; j++)
		{
			;
			eval(javascript[i].childNodes[j].data);
		}
	}
}
DynamicDataLoader.prototype.showDeeplink = function(product)
{
	if (product != null && product != undefined)
	{
		var productId = product.getProductId();
		if (productId != null && productId != undefined)
		{
			var deeplinkURL;
			if (this.deeplinkFromProduct == true)
				deeplinkURL = productId;
			else
				deeplinkURL = Browser.getRelativeURL(this.deeplinkurl + "&productId="
					+ encodeURIComponent(productId));
			this.screenbroker.openWindow(null, deeplinkURL, this.deepLinkTarget);
		}
	}
}
function DynamicDataLoaderCallback(target, url)
{
	this.target = target;
	this.url = url;
}
DynamicDataLoaderCallback.prototype.getLoadedAction = function()
{
	return new ObjectMethodAction(this, "parseDocument");
}
DynamicDataLoaderCallback.prototype.parseDocument = function(xmlDoc)
{
	DynamicDataLoader.instance.parseDocument(xmlDoc);
}
DynamicDataLoaderCallback.prototype.getErrorAction = function()
{
	return new ObjectMethodAction(this, "errorOccured");
}
DynamicDataLoaderCallback.prototype.errorOccured = function()
{
	alert('Couldn\' load data for target \'' + this.target + ' with url \'' + this.url + '\'');
}
