/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Action</DEPENDS>
    <DEPENDS>ConversationManager</DEPENDS>
</DEPENDENCIES>
*/
RoleplayManager.prototype             = new ConversationManager();
RoleplayManager.prototype.constructor = RoleplayManager;
RoleplayManager.superclass            = ConversationManager.prototype;
function RoleplayManager(sId, fakeQeaWorkItem, bInstantRecord)
{
  if (sId) { this.init(sId, fakeQeaWorkItem, bInstantRecord); }
}
var RoleplayManager_instances = new Array();
function RoleplayManager_getInstance(sId)
{
  return RoleplayManager_instances[sId];
}
RoleplayManager.prototype.init = function(sId, fakeQeaWorkItem, bInstantRecord)
{
  ;
  this.sId = sId;
  this.bInstantRecord = bInstantRecord;
  this.bRecordMode = false;
  this.bCanStartRecord = false;
  this.bCanStopRecord = false;
  this.bPlayAll = false;
  this.sActiveRoleId = null;
  this.oRoleplayBroker = null;
  this.oSoundRegistry = null;
  this.oSoundRecorderRegistry = null;
  this.oSelectedRoleInterval = null;
  this.bPlay = false;
  this.aPersonBroker = new Array();
  this.playPrevious = false;
  this.bAllRecorded = false;
  this.sFeedbackDisplayDomId = null;
  this.oFeedbackDisplayElement = null;
  this.nFeedbackTimeoutSeconds = 2;
  RoleplayManager_instances[sId] = this;
  RoleplayManager.superclass.init.call(this, this.sId, fakeQeaWorkItem);
}
RoleplayManager.prototype.start = function()
{
  RoleplayManager.superclass.start.call(this);
  if(this.sFeedbackDisplayDomId)
  {
    this.oFeedbackDisplayElement = Browser.getElementById(this.sFeedbackDisplayDomId);
  }
}
RoleplayManager.prototype.setRoleplayBroker = function(oRoleplayBroker)
{
  ;
  this.oRoleplayBroker = oRoleplayBroker;
  oRoleplayBroker.addRequestSoundPlayHandle(this.getRequestSoundPlayAction());
  oRoleplayBroker.addRequestSoundStopHandle(this.getRequestSoundStopAction());
  oRoleplayBroker.addRequestSoundPauseHandle(this.getRequestSoundPauseAction());
  oRoleplayBroker.addRequestSoundForwardHandle(this.getRequestSoundForwardAction());
  oRoleplayBroker.addRequestSoundRewindHandle(this.getRequestSoundRewindAction());
  oRoleplayBroker.addRequestRecordModeHandle(this.getRequestRecordModeAction());
  oRoleplayBroker.addRequestRecordHandle(this.getRequestRecordAction());
  oRoleplayBroker.addRequestContinueHandle(this.getRequestContinueAction());
  oRoleplayBroker.addRequestStopRecordHandle(this.getRequestStopRecordAction());
  oRoleplayBroker.addRequestStopAllPersonIntervalsHandle(this.getRequestStopAllPersonIntervalsAction());
  oRoleplayBroker.addRequestPlayAllPersonIntervalsHandle(this.getRequestPlayAllPersonIntervalsAction());
  oRoleplayBroker.addRequestForwardAllPersonIntervalsHandle(this.getRequestForwardAllPersonIntervalsAction());
  oRoleplayBroker.addRequestRewindAllPersonIntervalsHandle(this.getRequestRewindAllPersonIntervalsAction());
  oRoleplayBroker.addRequestPlayOnePersonIntervalHandle(this.getRequestPlayOnePersonIntervalAction());
  oRoleplayBroker.addRequestStopOnePersonIntervalHandle(this.getRequestStopOnePersonIntervalAction());
}
RoleplayManager.prototype.registerRoleInterval = function(oRoleInterval)
{
  ;
  var bAlreadyInArray = false;
  for ( var i = 0; i < this.aRoleIntervals.length; i++)
  {
    if ( this.aRoleIntervals[i].getId() == oRoleInterval.getId() )
    {
      bAlreadyInArray = true;
      break;
    }
  }
  if (bAlreadyInArray)
  {
    ;
  }
  else
  {
    this.aRoleIntervals.push(oRoleInterval);
  }
  oRoleInterval.setManager(this);
}
RoleplayManager.prototype.registerRoleplayElement = function(oRolePlayElement)
{
  ;
  RoleplayManager.superclass.registerConversationElement.call(this, oRolePlayElement);
}
RoleplayManager.prototype.registerPersonBroker = function(oPersonBroker, sRoleId)
{
  ;
  if( this.aPersonBroker[sRoleId] )
  {
    ;
  }
  else
  {
    this.aPersonBroker[sRoleId] = oPersonBroker;
    oPersonBroker.addRequestSetActiveHandle(this.getRequestSetPersonActiveAction(sRoleId));
  }
}
RoleplayManager.prototype.setSoundRegistry = function(oSoundRegistry)
{
  ;
  this.oSoundRegistry = oSoundRegistry;
}
RoleplayManager.prototype.setSoundRecorderRegistry = function(oSoundRecorderRegistry)
{
  ;
  this.oSoundRecorderRegistry = oSoundRecorderRegistry;
}
RoleplayManager.prototype.setFeedbackContainer = function(sFeedbackDisplayDomId, nFeedbackTimeoutSeconds)
{
  this.sFeedbackDisplayDomId = sFeedbackDisplayDomId;
  this.nFeedbackTimeoutSeconds = nFeedbackTimeoutSeconds;
}
RoleplayManager.prototype.timeChange = function(sAbsoluteTimeReached, bInfo)
{
  ;
  if ( this.bPlay )
  {
    for ( var i in this.aConversationElements )
    {
      var bActive = this.aConversationElements[i].bState;
      if ( this.aConversationElements[i].nStartTime <= sAbsoluteTimeReached && this.aConversationElements[i].nEndTime > sAbsoluteTimeReached)
      {
        if ( ! bActive )
        {
          this.aConversationElements[i].setActive(true);
        }
      }
      else
      {
        if ( bActive )
        {
          this.aConversationElements[i].setActive(false);
        }
      }
    }
  }
  if ( this.oActiveRoleInterval && ! this.oSelectedRoleInterval)
  {
    if ( sAbsoluteTimeReached >= this.oActiveRoleInterval.nEndTime )
    {
      if ( this.aProgressBars[this.oActiveRoleInterval.sRoleId] )
      {
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].doBlink(false);
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(false);
      }
      if ( this.aRoleIntervals[this.oActiveRoleInterval.nIndex + 1] )
      {
        this.oActiveRoleInterval = this.aRoleIntervals[this.oActiveRoleInterval.nIndex+1];
      }
    }
  }
  if ( this.oActiveRoleInterval && this.aProgressBars[this.oActiveRoleInterval.sRoleId] )
  {
    if (! this.bRecordMode || this.oActiveRoleInterval.sRoleId != this.sActiveRoleId)
    {
      if(this.sActiveRoleId != this.oActiveRoleInterval.sRoleId)
      {
        for (var key in this.aPersonBroker)
        {
            if (key == this.oActiveRoleInterval.sRoleId)
                this.aPersonBroker[key].setContributionActive();
            else
                this.aPersonBroker[key].setContributionInactive();
        }
      }
      var nMin = null;
      var nMax = null;
      nMin = this.oActiveRoleInterval.nStartTime;
      nMax = this.oActiveRoleInterval.nEndTime;
      this.aProgressBars[this.oActiveRoleInterval.sRoleId].setMinAndMax(nMin, nMax);
      this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(true);
      this.aProgressBars[this.oActiveRoleInterval.sRoleId].setValue(sAbsoluteTimeReached);
    }
  }
}
RoleplayManager.prototype.requestSetPersonActive = function(sRoleId)
{
  ;
  if ( ! this.bRecordMode )
  {
    if ( ! this.sActiveRoleId )
    {
      this.sActiveRoleId = sRoleId;
      if ( this.aPersonBroker[sRoleId] )
      {
        this.aPersonBroker[sRoleId].setActive();
      }
    }
    else
    {
      if ( this.sActiveRoleId == sRoleId )
      {
        this.sActiveRoleId = null;
        if ( this.aPersonBroker[sRoleId] )
        {
          this.aPersonBroker[sRoleId].setInactive();
        }
      }
      else
      {
        if ( this.aPersonBroker[this.sActiveRoleId] )
        {
          this.aPersonBroker[this.sActiveRoleId].setInactive();
        }
        this.sActiveRoleId = sRoleId;
        if ( this.aPersonBroker[sRoleId] )
        {
          this.aPersonBroker[sRoleId].setActive();
        }
      }
    }
  }
}
RoleplayManager.prototype.getPreviousRoleIntervall = function(oRoleInterval)
{
  ;
  var nextRoleInterval = null;
  if ( oRoleInterval )
  {
    if ( oRoleInterval.nIndex )
    {
      if( this.aRoleIntervals[oRoleInterval.nIndex-1] )
      {
        nextRoleInterval = this.aRoleIntervals[oRoleInterval.nIndex-1];
      }
    }
    else
    {
      nextRoleInterval = this.aRoleIntervals[0];
    }
  }
  else
  {
    if ( this.aRoleIntervals[0] )
    {
      nextRoleInterval = this.aRoleIntervals[0]
    }
  }
  return nextRoleInterval;
}
RoleplayManager.prototype.getNextRoleIntervall = function(oRoleInterval)
{
  ;
  var nextRoleInterval = null;
  if ( oRoleInterval )
  {
    if ( this.aRoleIntervals[oRoleInterval.nIndex+1] )
    {
      nextRoleInterval = this.aRoleIntervals[oRoleInterval.nIndex+1];
    }
  }
  else
  {
    if ( this.aRoleIntervals[0] )
    {
      nextRoleInterval = this.aRoleIntervals[0]
    }
  }
  return nextRoleInterval;
}
RoleplayManager.prototype.playNextRoleIntervall = function(oRoleInterval)
{
  ;
  if ( this.bPlay )
  {
    var nextRoleInterval = null;
    if ( this.playPrevious )
    {
      this.playPrevious = false;
      nextRoleInterval = this.getPreviousRoleIntervall(oRoleInterval);
      if ( this.aProgressBars[this.oActiveRoleInterval.sRoleId] )
      {
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].doBlink(false);
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(false);
      }
      if ( nextRoleInterval )
      {
        this.oActiveRoleInterval = nextRoleInterval;
      }
    }
    else
    {
      nextRoleInterval = this.getNextRoleIntervall(oRoleInterval);
    }
    if ( oRoleInterval && oRoleInterval.oRoleIntervalBroker)
    {
      oRoleInterval.oRoleIntervalBroker.setInactive();
    }
    if (nextRoleInterval)
    {
      if (nextRoleInterval.oRoleIntervalBroker)
      {
        nextRoleInterval.oRoleIntervalBroker.setActive();
      }
      if (  this.bPlayAll || nextRoleInterval.sRoleId != this.sActiveRoleId)
      {
        this.oRoleplayBroker.cannotRecord();
        nextRoleInterval.play();
      }
      else
      {
        this.bCanStartRecord = true;
        if(this.bInstantRecord)
        {
          this.requestRecord();
        }
        else
        {
          this.oRoleplayBroker.canRecord();
        }
      }
    }
    else
    {
      if ( this.oRoleplayBroker )
      {
        this.oRoleplayBroker.disableRecordMode();
        this.oRoleplayBroker.stoppedAllPersonIntervals();
      }
      if(!this.bAllRecorded)
      {
        this.bAllRecorded = true;
        if(this.workItem)
          this.workItem.evaluate();
      }
      this.bAllPlayed = true;
      this.bPlay = false;
      this.bPlayAll = false;
      if (this.oActiveRoleInterval && this.aProgressBars[this.oActiveRoleInterval.sRoleId])
      {
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(false);
      }
      this.oActiveRoleInterval = null;
      this.soundStopChange();
    }
  }
}
RoleplayManager.prototype.roleIntervalPlayed = function(oRoleInterval)
{
  ;
  if (this.oSelectedRoleInterval)
  {
    if ( this.aProgressBars[this.oSelectedRoleInterval.sRoleId] )
    {
      this.aProgressBars[this.oSelectedRoleInterval.sRoleId].setActive(false);
    }
    if ( oRoleInterval.sRoleId == this.sActiveRoleId )
    {
      this.oRoleplayBroker.cannotStopRecord();
      this.bCanStopRecord = false;
      this.bCanStartRecord = true;
      if(!this.bInstantRecord)
      {
        this.oRoleplayBroker.canRecord();
      }
    }
    this.oSelectedRoleInterval
  }
  if ( ! this.bAllPlayed || this.bPlayAll)
  {
    this.playNextRoleIntervall(oRoleInterval);
  }
  if(this.bInstantRecord)
  {
    this.requestRecord();
  }
}
RoleplayManager.prototype.showFeedback = function(sFeedbackText)
{
  ;
  if(this.oFeedbackDisplayElement)
  {
    this.oFeedbackDisplayElement.innerHTML = sFeedbackText;
  }
  if(this.oRoleplayBroker)
  {
    this.oRoleplayBroker.showFeedback();
  }
  window.setTimeout('RoleplayManager_getInstance(\''+this.sId+'\').clearFeedback();', (this.nFeedbackTimeoutSeconds * 1000));
}
RoleplayManager.prototype.clearFeedback = function()
{
  ;
  if(this.oFeedbackDisplayElement)
  {
    this.oFeedbackDisplayElement.innerHTML = '';
  }
  if(this.oRoleplayBroker)
  {
    this.oRoleplayBroker.hideFeedback();
  }
}
RoleplayManager.prototype.timeLimitReached = function(oRoleInterval)
{
  ;
  if (this.oRoleplayBroker)
  {
    this.oRoleplayBroker.timeLimitReached();
  }
}
RoleplayManager.prototype.requestSoundPlay = function()
{
  ;
  if ( (!this.bRecordMode || this.bAllPlayed) && this.oSoundBroker)
  {
    this.requestStopAllPersonIntervals();
    this.oSoundBroker.requestSoundStart();
    this.bPlay = true;
  }
}
RoleplayManager.prototype.requestSoundStop = function()
{
  ;
  if ( (!this.bRecordMode || this.bAllPlayed) && this.oSoundBroker)
  {
    this.oSoundBroker.requestSoundStop();
  }
}
RoleplayManager.prototype.requestSoundForward = function()
{
  ;
  if ( (!this.bRecordMode || this.bAllPlayed) && this.oSoundBroker)
  {
    this.oSoundBroker.requestSoundForward();
  }
}
RoleplayManager.prototype.requestSoundRewind = function()
{
  ;
  if ( (!this.bRecordMode || this.bAllPlayed) && this.oSoundBroker)
  {
    this.oSoundBroker.requestSoundRewind();
  }
}
RoleplayManager.prototype.requestSoundPause = function()
{
  ;
  if ( (!this.bRecordMode || this.bAllPlayed) && this.oSoundBroker)
  {
    this.oSoundBroker.requestSoundPause();
  }
}
RoleplayManager.prototype.requestRecord = function()
{
  ;
  if ( this.bCanStartRecord )
  {
    this.bPlay = true;
    this.bCanStartRecord = false;
    this.bCanStopRecord = true;
    this.oRoleplayBroker.cannotRecord();
    this.oRoleplayBroker.canStopRecord();
    if ( this.aProgressBars[this.oActiveRoleInterval.sRoleId] )
    {
      this.aProgressBars[this.oActiveRoleInterval.sRoleId].doBlink(true);
    }
    this.oActiveRoleInterval.record();
  }
}
RoleplayManager.prototype.requestStopRecord = function()
{
  ;
  if ( this.bCanStopRecord )
  {
    if ( this.aProgressBars[this.oActiveRoleInterval.sRoleId] )
    {
      this.aProgressBars[this.oActiveRoleInterval.sRoleId].doBlink(false);
    }
    this.bCanStopRecord = false;
    this.oRoleplayBroker.cannotStopRecord();
    this.oActiveRoleInterval.stopRecord();
  }
}
RoleplayManager.prototype.requestContinue = function()
{
  ;
  if(!this.bAllPlayed && !this.bPlayAll && this.oActiveRoleInterval)
  {
    if ( this.bCanStopRecord )
    {
      this.requestStopRecord();
    }
    else
    {
      this.oActiveRoleInterval.stopRecord();
    }
  }
}
RoleplayManager.prototype.requestSetRoleIntervalActive = function(oRoleInterval)
{
  ;
  if ( (! ( this.oSelectedRoleInterval && this.oSelectedRoleInterval.bIsActive ) )&& (! ( this.oActiveRoleInterval && this.oActiveRoleInterval.bIsActive ) ) )
  {
    if ( this.bAllPlayed && ! this.bPlayAll)
    {
      this.soundStopChange();
      if ( this.oSelectedRoleInterval )
      {
        this.oSelectedRoleInterval.oRoleIntervalBroker.setInactive();
        this.oSelectedRoleInterval.stopRecord();
      }
      this.oSelectedRoleInterval = oRoleInterval;
      if ( this.oActiveRoleInterval )
      {
        this.oActiveRoleInterval.oRoleIntervalBroker.setInactive();
        this.oActiveRoleInterval.stopRecord();
      }
      this.oActiveRoleInterval = oRoleInterval;
      if ( oRoleInterval.sRoleId != this.sActiveRoleId) 
      {
        this.oRoleplayBroker.cannotStopRecord();
        this.oRoleplayBroker.cannotRecord();
        this.bCanStopRecord = false;
        this.bCanStartRecord = false;
        oRoleInterval.oRoleIntervalBroker.setActive();
      }
      else
      {
        this.oRoleplayBroker.cannotStopRecord();
        this.bCanStopRecord = false;
        this.bCanStartRecord = true;
        oRoleInterval.oRoleIntervalBroker.setActive();
        if(this.bInstantRecord)
        {
          this.requestRecord();
        }
        else
        {
          this.oRoleplayBroker.canRecord();
        }
      }
    }
  }
}
RoleplayManager.prototype.requestRecordMode = function()
{
  ;
  if ( ! this.bRecordMode && this.sActiveRoleId )
  {
    if(this.bPlay)
    {
      this.oSoundBroker.addSoundStoppedHandle(new ObjectMethodAction(this, 'switchToRecordMode'));
      this.requestSoundStop();
    }
    else
    {
      this.switchToRecordMode();
    }
  }
}
RoleplayManager.prototype.switchToRecordMode = function()
{
  ;
  if ( ! this.bRecordMode && this.sActiveRoleId )
  {
    if(this.workItemAdapter)
      this.workItemAdapter.doStart();
    this.oRoleplayBroker.enableRecordMode();
    this.bRecordMode = true;
    this.bPlay = true;
    this.oActiveRoleInterval = this.aRoleIntervals[0];
    this.playNextRoleIntervall(null);
  }
}
RoleplayManager.prototype.requestRewindAllPersonIntervals = function()
{
  ;
  if ( this.bPlayAll )
  {
    this.playPrevious = true;
    if (this.oActiveRoleInterval )
    {
      this.oActiveRoleInterval.stopRecord();
    }
  }
}
RoleplayManager.prototype.requestForwardAllPersonIntervals = function()
{
  ;
  if ( this.bPlayAll )
  {
    if (this.oActiveRoleInterval )
    {
      this.oActiveRoleInterval.stopRecord();
      this.oActiveRoleInterval.oRoleIntervalBroker.setInactive();
    }
  }
}
RoleplayManager.prototype.requestStopAllPersonIntervals = function()
{
  ;
  if ( this.bPlayAll )
  {
    this.bPlay = false;
    this.bPlayAll = false;
    this.soundStopChange();
    if (this.oActiveRoleInterval )
    {
      this.oActiveRoleInterval.stopRecord();
      this.oActiveRoleInterval.oRoleIntervalBroker.setInactive();
    }
    if ( this.oRoleplayBroker )
    {
      this.oRoleplayBroker.stoppedAllPersonIntervals();
    }
  }
}
RoleplayManager.prototype.requestPlayAllPersonIntervals = function()
{
  ;
  if (
    (! ( this.oSelectedRoleInterval && this.oSelectedRoleInterval.bIsActive ) )&&
    (! ( this.oActiveRoleInterval && this.oActiveRoleInterval.bIsActive ) ) &&
    ( ! this.bPlayAll && this.bAllPlayed ))
  {
    this.requestSoundStop();
    if ( this.oSelectedRoleInterval )
    {
      this.oSelectedRoleInterval.oRoleIntervalBroker.setInactive();
      if ( this.bCanStopRecord )
      {
      this.requestStopRecord();
      }
      this.oSelectedRoleInterval = null;
    }
    this.bPlayAll = true;
    this.soundStopChange();
    if ( this.oRoleplayBroker )
    {
      this.oRoleplayBroker.startedAllPersonIntervals();
    }
    this.bPlay = true;
    this.oActiveRoleInterval = this.aRoleIntervals[0];
    this.playNextRoleIntervall(null);
  }
}
RoleplayManager.prototype.requestStopOnePersonInterval = function()
{
  ;
  if ( this.oSelectedRoleInterval )
  {
    this.oSelectedRoleInterval.stopRecord();
  }
}
RoleplayManager.prototype.requestPlayOnePersonInterval = function()
{
  ;
  if ( this.oSelectedRoleInterval)
  {
    this.oSelectedRoleInterval.play();
  }
}
RoleplayManager.prototype.getRequestSetPersonActiveAction = function(sRoleId)
{
  return new ObjectMethodAction(this, "requestSetPersonActive", sRoleId);
}
RoleplayManager.prototype.getRequestSoundPlayAction = function()
{
  return new ObjectMethodAction(this, "requestSoundPlay");
}
RoleplayManager.prototype.getRequestSoundStopAction = function()
{
  return new ObjectMethodAction(this, "requestSoundStop");
}
RoleplayManager.prototype.getRequestSoundPauseAction = function()
{
  return new ObjectMethodAction(this, "requestSoundPause");
}
RoleplayManager.prototype.getRequestRecordModeAction = function()
{
  return new ObjectMethodAction(this, "requestRecordMode");
}
RoleplayManager.prototype.getRequestRecordAction = function()
{
  return new ObjectMethodAction(this, "requestRecord");
}
RoleplayManager.prototype.getRequestStopRecordAction = function()
{
  return new ObjectMethodAction(this, "requestStopRecord");
}
RoleplayManager.prototype.getRequestSoundForwardAction = function()
{
  return new ObjectMethodAction(this, "requestSoundForward");
}
RoleplayManager.prototype.getRequestSoundRewindAction = function()
{
  return new ObjectMethodAction(this, "requestSoundRewind");
}
RoleplayManager.prototype.getRequestStopAllPersonIntervalsAction = function()
{
  return new ObjectMethodAction(this, "requestStopAllPersonIntervals");
}
RoleplayManager.prototype.getRequestPlayAllPersonIntervalsAction = function()
{
  return new ObjectMethodAction(this, "requestPlayAllPersonIntervals");
}
RoleplayManager.prototype.getRequestForwardAllPersonIntervalsAction = function()
{
  return new ObjectMethodAction(this, "requestForwardAllPersonIntervals");
}
RoleplayManager.prototype.getRequestRewindAllPersonIntervalsAction = function()
{
  return new ObjectMethodAction(this, "requestRewindAllPersonIntervals");
}
RoleplayManager.prototype.getRequestStopOnePersonIntervalAction = function()
{
  return new ObjectMethodAction(this, "requestStopOnePersonInterval");
}
RoleplayManager.prototype.getRequestPlayOnePersonIntervalAction = function()
{
  return new ObjectMethodAction(this, "requestPlayOnePersonInterval");
}
RoleplayManager.prototype.getRequestContinueAction = function()
{
  return new ObjectMethodAction(this, "requestContinue");
}
