/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
DropDownOption.prototype             = new DomletCtr();
DropDownOption.prototype.constructor = DropDownOption;
DropDownOption.superclass            = DomletCtr.prototype;
function DropDownOption(sId, sWidgetDomId, sBgSelectedColor, sFgSelectedColor, sBgHighlightColor, sFgHighlightColor)
{
  if (sId) { this.init(sId, sWidgetDomId, sBgSelectedColor, sFgSelectedColor, sBgHighlightColor, sFgHighlightColor); }
}
DropDownOption.prototype.init = function(sId, sWidgetDomId, sBgSelectedColor, sFgSelectedColor, sBgHighlightColor, sFgHighlightColor)
{
  ;
  this.sBgSelectedColor=null;
  this.sFgSelectedColor=null;
  this.sBgHighlightColor=null;
  this.sFgHighlightColor=null;
  this.sFgTipColor=null;
  this.sFgNormalColor=null;
  this.sBgInactiveColor=null;
  this.sFgInactiveColor=null;
  this.sId = sId;
  this.modelItem = null;
  this.broker = null;
  this.widget = document.getElementById(sWidgetDomId);
  this.sWidgetDomId = sWidgetDomId;
  if (this.widget == null)
  {
    ;
  }
  this.sBgInactiveColor = Browser.getStyleById(this.sWidgetDomId, 'background');
  this.sFgInactiveColor = Browser.getStyleById(this.sWidgetDomId, 'color');
  if(!this.sBgInactiveColor)
  {
    this.sBgInactiveColor = '#FFFFFF';
  }
  if(!this.sFgInactiveColor)
  {
    this.sFgInactiveColor = '#000000';
  }
  if (sBgSelectedColor)
  {
    this.sBgSelectedColor = sBgSelectedColor;
  }
  if(sFgSelectedColor)
  {
    this.sFgSelectedColor = sFgSelectedColor;
  }
  if(sBgHighlightColor)
  {
    this.sBgHighlightColor = sBgHighlightColor;
  }
  if(sFgHighlightColor)
  {
    this.sFgHighlightColor = sFgHighlightColor;
  }
  DropDownOption.superclass.init.call(this, sWidgetDomId, sId, this);
  this.addDomlet(new Domlet(
      this.sWidgetDomId,      
      this.sWidgetDomId,      
      this,                   
      new Array('click', 'mouseover', 'mouseout')) 
  )
}
DropDownOption.prototype.getId = function()
{
  return this.sId;
}
DropDownOption.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
DropDownOption.prototype.getModelItem = function()
{
  return this.modelItem;
}
DropDownOption.prototype.setBroker = function(broker)
{
  ;
  this.broker = broker;
}
DropDownOption.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  else
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      switch (model.getOrigin())
      {
        case 'system_solution':
            if (this.broker) { this.broker.showSolution(); }
          break;
        default:
          if (this.broker) { this.broker.showUnassigned(); }
          if(this.sBgSelectedColor)
          {
            this.domlets[this.sWidgetDomId].setStyle('background', this.sBgInactiveColor);
          }
          if(this.sFgSelectedColor)
          {
            this.domlets[this.sWidgetDomId].setStyle('color', this.sFgInactiveColor);
          }
          break;
      }
    }
    else if (nCount == 1)
    {
      switch (model.getOrigin())
      {
         case 'system_set':
         case 'user':
          if(this.sBgSelectedColor)
          {
            this.domlets[this.sWidgetDomId].setStyle('background', this.sBgSelectedColor);
          }
          if (this.sFgSelectedColor)
          {
            this.domlets[this.sWidgetDomId].setStyle('color', this.sFgSelectedColor);
          }
          break;
        case 'system_solution':
          if (model.getEvaluation().isActive())
          {
            if (this.broker) { this.broker.showSolution(); }
          }
          break;
        case 'system_setpartial':
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_approve':
          if (this.broker) { this.broker.showTipApproveCorrect(); }
          break;
        case 'system_brand':
          if (this.broker) { this.broker.showTipBrandWrong(); }
          break;
      }
    }
    else
    {
      ;
    }
  }
}
DropDownOption.prototype.eventFromChild = function(childName, eventType, event)
{
  //;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
     case "click" :
      ;
      this.clickHandler(domlet, event);
      break;
     case "mouseover" :
      ;
      this.mouseoverHandler(domlet, event);
      break;
     case "mouseout" :
      ;
      this.mouseoutHandler(domlet, event);
      break;
  }
}
DropDownOption.prototype.setBgSelectedColor = function( sBgSelectedColor )
{
  this.sBgSelectedColor = sBgSelectedColor;
}
DropDownOption.prototype.setFgSelectedColor = function( sFgSelectedColor )
{
  this.sFgSelectedColor = sFgSelectedColor;
}
DropDownOption.prototype.setBgHighlightColor = function( sBgHighlightColor )
{
  this.sBgHighlightColor = sBgHighlightColor;
}
DropDownOption.prototype.setFgHighlightColor = function( sFgHighlightColor )
{
  this.sFgHighlightColor = sFgHighlightColor;
}
DropDownOption.prototype.setFgTipColor = function( sFgTipColor )
{
  this.sFgTipColor = sFgTipColor;
}
DropDownOption.prototype.setFgNormalColor = function( sFgNormalColor )
{
  this.sFgNormalColor = sFgNormalColor;
}
DropDownOption.prototype.clickHandler = function(domlet, event)
{
  ;
    this.modelItem.setActive(true);
}
DropDownOption.prototype.mouseoverHandler = function(domlet, event)
{
  ;
  if(this.sBgHighlightColor)
  {
    this.domlets[this.sWidgetDomId].setStyle('background', this.sBgHighlightColor);
  }
  if (this.sFgHighlightColor)
  {
    this.domlets[this.sWidgetDomId].setStyle('color', this.sFgHighlightColor);
  }
}
DropDownOption.prototype.mouseoutHandler = function(domlet, event)
{
  if(! this.modelItem.isActive())
  {
    ;
    if (this.sBgHighlightColor)
    {
      this.domlets[this.sWidgetDomId].setStyle('background', this.sBgInactiveColor);
    }
    this.domlets[this.sWidgetDomId].setStyle('color', this.sFgInactiveColor);
    if ( this.sFgNormalColor )
    {
      this.domlets[this.sWidgetDomId].setStyle('color', this.sFgNormalColor);
    }
  }
  else
  {
    ;
    if (this.sBgHighlightColor)
    {
      this.domlets[this.sWidgetDomId].setStyle('background', this.sBgSelectedColor);
    }
    if (this.sFgHighlightColor)
    {
      this.domlets[this.sWidgetDomId].setStyle('color', this.sFgSelectedColor);
    }
  }
}
