/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
</DEPENDENCIES>
*/
function JokerStrategyFiftyFifty( sId )
{
  if( sId )
    this.init(sId);
}
JokerStrategyFiftyFifty.prototype.init = function( sId )
{
  ;
  this.sId = sId;
  this.aEvaluations = new Array();
  this.aEvaluationHandles = new Array();
  this.aPlayedHandles = new Array();
}
JokerStrategyFiftyFifty.prototype.getId = function()
{
  return this.sId;
}
JokerStrategyFiftyFifty.prototype.registerEvaluation = function( evaluation )
{
  if( evaluation )
  {
    this.aEvaluations.push(evaluation);
  }
}
JokerStrategyFiftyFifty.prototype.registerEvaluationAction = function( evaluation, action )
{
  if( evaluation && action )
  {
    this.aEvaluationHandles[evaluation.getId()] = action;
  }
}
JokerStrategyFiftyFifty.prototype.playJoker = function()
{
  ;
  var numToDisable = Math.floor(this.aEvaluations.length / 2);
  var indices = new Array();
  for( var i = 0; i < this.aEvaluations.length; i++ )
  {
    if( this.isSuitableEvaluation(this.aEvaluations[i]) )
      indices.push(i);
  }
  if( indices.length > numToDisable )
    this.shuffleIndices(indices);
  for( var i = 0; i < indices.length && i < numToDisable; i++ )
  {
    var evaluation = this.aEvaluations[indices[i]];
    this.aEvaluationHandles[evaluation.getId()].invoke();
  }
}
JokerStrategyFiftyFifty.prototype.getPlayJokerAction = function()
{
  ;
  return new ObjectMethodAction(this, "playJoker");
}
JokerStrategyFiftyFifty.prototype.jokerPlayed = function()
{
  ;
  for( var i = 0; i < this.aPlayedHandles.length; i++ )
  {
    this.aPlayedHandles[i].invoke();
  }
}
JokerStrategyFiftyFifty.prototype.addJokerPlayedHandle = function( action )
{
  ;
  this.aPlayedHandles.push(action);
}
JokerStrategyFiftyFifty.prototype.shuffleIndices = function( indices )
{
  for( var i = indices.length-1; i > 1; i-- )
  {
    var j = Math.round(Math.random() * indices.length);
    var tmp = indices[i];
    indices[i] = indices[j];
    indices[j] = tmp;
  }
}
JokerStrategyFiftyFifty.prototype.isSuitableEvaluation = function( evaluation )
{
  if( evaluation && !evaluation.isCorrect() && !evaluation.isActive() )
    return true;
  else
    return false;
}
