/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>BasicQeaTipStrategy</DEPENDS>
    <DEPENDS>ShowCharactersQeaTipStrategy</DEPENDS>
</DEPENDENCIES>
*/
RemoveWrongSpacesQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
RemoveWrongSpacesQeaTipStrategy.prototype.constructor = RemoveWrongSpacesQeaTipStrategy;
RemoveWrongSpacesQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function RemoveWrongSpacesQeaTipStrategy(sId, bJustUserSelect)
{
  if (sId) { this.init(sId, bJustUserSelect); }
}
RemoveWrongSpacesQeaTipStrategy.prototype.init = function(sId, bJustUserSelect)
{
  ;
  this.bJustUserSelect = bJustUserSelect;
  ShowCharactersQeaTipStrategy.superclass.init.call(this, sId);
  this.bCanCycleTips = false; 
}
RemoveWrongSpacesQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = this.workItem.isCurrentWorkItem();
  }
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = evaluation.hasUserFocus();
  }
  if (bHasTip)
  {
    var sCorrectText = evaluation.getAnswer().getText();
    if(evaluation.getQuestion().getActiveComplement())
    {
      var sActualText = evaluation.getQuestion().getActiveComplement().getText();
      var nMissingSpaces = 0;
      bHasTip = false;
      for( var i = 0; i < sCorrectText.length && i < sActualText.length; i++)
      {
        if (sActualText.charAt(i - nMissingSpaces) == ' ' && sCorrectText.charAt(i) != ' ' )
        {
          bHasTip = true;
          break;
        }
        if (sActualText.charAt(i - nMissingSpaces) != ' ' && sCorrectText.charAt(i) == ' ' )
        { 
          nMissingSpaces++;
        }
      }
    }
    else
    {
      bHasTip = false;
    }
  }
  return bHasTip;
}
RemoveWrongSpacesQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  var sCorrectText = evaluation.getAnswer().getText();
  var sActualText = evaluation.getQuestion().getActiveComplement().getText();
  var nMissingSpaces = 0;
  var sText = '';
  var i = null;
  for( i = 0; i < sCorrectText.length && i < sActualText.length; i++)
  {
    if (sActualText.charAt(i - nMissingSpaces) == ' ' && sCorrectText.charAt(i) != ' ' )
    {
      break;
    }
    if (sActualText.charAt(i - nMissingSpaces) != ' ' && sCorrectText.charAt(i) == ' ' )
    { 
      nMissingSpaces++;
    }
  }
  sText = sActualText.substr( 0, i - nMissingSpaces) +  sActualText.substr( i + 1 - nMissingSpaces , sActualText.length)
  if (sText == sCorrectText)
  {
     evaluation.setActive(true, 'system_set');
  }
  else
  {
    var answer = this.workItem.getOrCreateAnswerByText(sText);
    var e = this.workItem.getOrCreateEvaluation(evaluation.getQuestion(), answer);
    e.setActive(true, 'system_setpartial');
    this.workItem.willChange(evaluation);
    evaluation.setSystemPartialConstuction(true); 
  }
}
AddCorrectSpacesQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
AddCorrectSpacesQeaTipStrategy.prototype.constructor = AddCorrectSpacesQeaTipStrategy;
AddCorrectSpacesQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function AddCorrectSpacesQeaTipStrategy(sId, bJustUserSelect)
{
  if (sId) { this.init(sId, bJustUserSelect); }
}
AddCorrectSpacesQeaTipStrategy.prototype.init = function(sId, bJustUserSelect)
{
  ;
  this.bJustUserSelect = bJustUserSelect;
  ShowCharactersQeaTipStrategy.superclass.init.call(this, sId);
  this.bCanCycleTips = false; 
}
AddCorrectSpacesQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = this.workItem.isCurrentWorkItem();
  }
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = evaluation.hasUserFocus();
  }
  if (bHasTip)
  {
    var sCorrectText = evaluation.getAnswer().getText();
    if(evaluation.getQuestion().getActiveComplement())
    {
      var sActualText = evaluation.getQuestion().getActiveComplement().getText();
      var nWrongSpaces = 0;
      bHasTip = false;
      for( var i = 0; i < sCorrectText.length && i < sActualText.length; i++)
      {
        if (sActualText.charAt(i + nWrongSpaces) != ' ' && sCorrectText.charAt(i) == ' ' )
        {
          bHasTip = true;
          break;
        }
        if (sActualText.charAt(i + nWrongSpaces) == ' ' && sCorrectText.charAt(i) != ' ' )
        { 
          nWrongSpaces++;
        }
      }
    }
    else
    {
      bHasTip = false;
    }
  }
  return bHasTip;
}
AddCorrectSpacesQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  var sCorrectText = evaluation.getAnswer().getText();
  var sActualText = evaluation.getQuestion().getActiveComplement().getText();
  var nWrongSpaces = 0;
  var sText = '';
  var i = null;
  for( var i = 0; i < sCorrectText.length && i < sActualText.length; i++)
  {
    if (sActualText.charAt(i + nWrongSpaces) != ' ' && sCorrectText.charAt(i) == ' ' )
    {
      break;
    }
    if (sActualText.charAt(i + nWrongSpaces) == ' ' && sCorrectText.charAt(i) != ' ' )
    { 
      nWrongSpaces++;
    }
  }
  sText = sActualText.substr( 0, i + nWrongSpaces) + ' ' +  sActualText.substr( i + nWrongSpaces, sActualText.length)
  if (sText == sCorrectText)
  {
     evaluation.setActive(true, 'system_set');
  }
  else
  {
    var answer = this.workItem.getOrCreateAnswerByText(sText);
    var e = this.workItem.getOrCreateEvaluation(evaluation.getQuestion(), answer);
    e.setActive(true, 'system_setpartial');
    this.workItem.willChange(evaluation);
    evaluation.setSystemPartialConstuction(true); 
  }
}
RemoveOrAddFirstSpaceQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
RemoveOrAddFirstSpaceQeaTipStrategy.prototype.constructor = RemoveOrAddFirstSpaceQeaTipStrategy;
RemoveOrAddFirstSpaceQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function RemoveOrAddFirstSpaceQeaTipStrategy(sId, bJustUserSelect)
{
  if (sId) { this.init(sId, bJustUserSelect); }
}
RemoveOrAddFirstSpaceQeaTipStrategy.prototype.init = function(sId, bJustUserSelect)
{
  ;
  this.bJustUserSelect = bJustUserSelect;
  ShowCharactersQeaTipStrategy.superclass.init.call(this, sId);
  this.bCanCycleTips = false; 
}
RemoveOrAddFirstSpaceQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = this.workItem.isCurrentWorkItem();
  }
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = evaluation.hasUserFocus();
  }
 if(this.bJustUserSelect)
    ;
  if (bHasTip)
  {
    var sCorrectText = evaluation.getAnswer().getText();
    if(evaluation.getQuestion().getActiveComplement())
    {
      var sActualText = evaluation.getQuestion().getActiveComplement().getText();
      bHasTip = false;
      for( var i = 0; i < sCorrectText.length && i < sActualText.length; i++)
      {
        if (sActualText.charAt(i) != ' ' && sCorrectText.charAt(i) == ' ' )
        {
          bHasTip = true;
          break;
        }
        if (sActualText.charAt(i) == ' ' && sCorrectText.charAt(i) != ' ' )
        { 
          bHasTip = true;
          break;
        }
      }
    }
    else
    {
      bHasTip = false;
    }
  }
  return bHasTip;
}
RemoveOrAddFirstSpaceQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  var sCorrectText = evaluation.getAnswer().getText();
  var sActualText = evaluation.getQuestion().getActiveComplement().getText();
  var sText = '';
  var i = null;
  var bRemoveSpace = null;
  for( var i = 0; i < sCorrectText.length && i < sActualText.length; i++)
  {
    if (sActualText.charAt(i) != ' ' && sCorrectText.charAt(i) == ' ' )
    {
      break;
    }
    if (sActualText.charAt(i ) == ' ' && sCorrectText.charAt(i) != ' ' )
    { 
      bRemoveSpace = true;
      break;
    }
  }
  if ( bRemoveSpace )
  {
    sText = sActualText.substr( 0, i ) +  sActualText.substr( i + 1 , sActualText.length)
  }
  else
  {
    sText = sActualText.substr( 0, i ) + ' ' +  sActualText.substr( i , sActualText.length)
  }
  if (sText == sCorrectText)
  {
     evaluation.setActive(true, 'system_set');
  }
  else
  {
    var answer = this.workItem.getOrCreateAnswerByText(sText);
    var e = this.workItem.getOrCreateEvaluation(evaluation.getQuestion(), answer);
    e.setActive(true, 'system_setpartial');
    this.workItem.willChange(evaluation);
    evaluation.setSystemPartialConstuction(true); 
  }
}
RemoveWrongSpacesOnSelectedQeaTipStrategy.prototype             = new RemoveWrongSpacesQeaTipStrategy();
RemoveWrongSpacesOnSelectedQeaTipStrategy.prototype.constructor = RemoveWrongSpacesOnSelectedQeaTipStrategy;
RemoveWrongSpacesOnSelectedQeaTipStrategy.superclass            = RemoveWrongSpacesQeaTipStrategy.prototype;
function RemoveWrongSpacesOnSelectedQeaTipStrategy(sId)
{
  if (sId) { this.init(sId, true); }
}
AddCorrectSpacesOnSelectedQeaTipStrategy.prototype             = new AddCorrectSpacesQeaTipStrategy();
AddCorrectSpacesOnSelectedQeaTipStrategy.prototype.constructor = AddCorrectSpacesOnSelectedQeaTipStrategy;
AddCorrectSpacesOnSelectedQeaTipStrategy.superclass            = AddCorrectSpacesQeaTipStrategy.prototype;
function AddCorrectSpacesOnSelectedQeaTipStrategy(sId)
{
  if (sId) { this.init(sId, true); }
}
RemoveOrAddFirstSpaceOnSelectedQeaTipStrategy.prototype             = new RemoveOrAddFirstSpaceQeaTipStrategy();
RemoveOrAddFirstSpaceOnSelectedQeaTipStrategy.prototype.constructor = RemoveOrAddFirstSpaceOnSelectedQeaTipStrategy;
RemoveOrAddFirstSpaceOnSelectedQeaTipStrategy.superclass            = RemoveOrAddFirstSpaceQeaTipStrategy.prototype;
function RemoveOrAddFirstSpaceOnSelectedQeaTipStrategy(sId)
{
  if (sId) { this.init(sId, true); }
}
