/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>FinalObjectMethodAction</DEPENDS>
</DEPENDENCIES>
*/
function ScreenController(sId, contentId, popupAllowed, popup)
{
    this.init(sId, contentId, popupAllowed, popup)
}
ScreenController.prototype.init = function(sId, contentId, popupAllowed, popup)
{
  ;
  this.sId = sId;
  this.contentId = contentId;
  this.screenBroker = null;
  this.popupAllowed = popupAllowed;
  this.popup = popup;
  this.openerFrame = false;
}
ScreenController.prototype.start = function()
{
  ;
  if(this.popup)
    this.startPopupAware();
  if(this.screenBroker)
  {
    Browser.addUnloadHandle(new ObjectMethodAction(this.screenBroker, 'doUnload'));
    this.screenBroker.addReplaceHandle(new FinalObjectMethodAction(this, "doTheReplace"));
    this.screenBroker.addReloadHandle(new FinalObjectMethodAction(this, "doTheReload"));
    this.screenBroker.addLogoutHandle(new FinalObjectMethodAction(this, "doTheLogout"));
  }
}
ScreenController.prototype.startPopupAware = function()
{
  if (opener)
  {
    if (opener.top.frames.length > 1)
    {
      this.openerFrame = true;
    }
  }
  if (opener && !this.openerFrame)
  {
      if (opener.screenBroker)
      {
        opener.screenBroker.notifyPopupAware(this.screenBroker);
      }
  }
  else
  {
    if (opener)
    {
      if (this.openerFrame && opener.top.frames.length < 2)
      {
	    if (Browser.getId() == 'moz')
	    {
	      top.close();
	    }
	    else
	    {
	      self.close();
	    }
      }
      else if (opener.screenBroker)
      {
        opener.screenBroker.notifyPopupAware(this.screenBroker);
      }
    }
    else if (this.openerFrame)
    {
      if (Browser.getId() == 'moz')
      {
        top.close();
      }
      else
      {
        self.close();
      }
    }
  }
  var thisScreenController = this;
  var callback = function()
  {
     thisScreenController.startPopupAware();
  };
  window.setTimeout(callback, 1000);
}
if (openedWindows == undefined) {
    ;
    var openedWindows = new Object();
}
ScreenController.prototype.register = function(screenBroker)
{
    this.screenBroker = screenBroker;
    this.screenBroker.setScreenController(this);
}
ScreenController.prototype.shouldReplace = function(extURL)
{
  this.screenBroker.doLeave();
  this.screenBroker.doReplace(extURL);
}
ScreenController.prototype.shouldReload = function()
{
  this.screenBroker.doLeave();
  this.screenBroker.doReload();
}
ScreenController.prototype.shouldPopup = function(extURL, windowName, width, height, scrollbars, resizable)
{
    this.doThePopup(extURL, windowName, width, height, scrollbars, resizable);
}
ScreenController.prototype.shouldIFrame = function(extURL, windowName)
{
    this.doTheIFrame(extURL, windowName);
}
ScreenController.prototype.shouldInvokeServletMethod = function(extURL, successAction, errorAction)
{
    this.doTheInvokeServletMethod(extURL, successAction, errorAction);
}
ScreenController.prototype.shouldCallServer = function(extURL, successAction, errorAction)
{
    this.doTheCallServer(extURL, successAction, errorAction);
}
ScreenController.prototype.shouldClosePopup = function(windowName)
{
    this.doTheClosePopup(windowName);
}
ScreenController.prototype.shouldReloadPopup = function(extURL, windowName)
{
    this.doTheReloadPopup(extURL, windowName);
}
ScreenController.prototype.doTheReplace = function(extURL)
{
  ;
  try
  {
    window.location.href = extURL;
  }
  catch(exeption)
  {
  }
}
ScreenController.prototype.doTheReload = function()
{
  ;
  this.screenBroker.doLeave();
  window.location.reload();
}
ScreenController.prototype.doTheReloadPopup = function(extURL, windowName)
{
    var wind = window.open('', windowName);
    if(wind)
        wind.location.href = extURL;
    openedWindows[windowName] = wind;
}
ScreenController.prototype.doThePopup = function(extURL, windowName, width, height, scrollbars, resizable)
{
  ;
  if (extURL == null) extURL = "/error";
  if (width == null) width = 850;
  if (height == null) height = 650;
  if (windowName == null) windowName = 'scola-af' + new Date().getTime();
  windowName = windowName.replace (/\W/g, "");
  var wind = window.open('', windowName, 'width=' + width + ', height=' + height + ', menubar=no, scrollbars=' + scrollbars + ', toolbar=no, status=no, resizable=' + resizable);
  if (wind)
  {
    wind.location.href = extURL;
  	wind.focus();
  }
  ;
  openedWindows[windowName] = wind;
}
ScreenController.prototype.doTheIFrame = function(extURL, windowName)
{
  ;
  if (extURL == null) extURL = "/error";
  var width = 350;
  var height = 200;
  if (windowName == null) windowName = 'scola-af' + new Date().getTime();
  var wind = window.open('', windowName, 'width=' + width + ', height=' + height + ', menubar=no, scrollbars=no, toolbar=no, status=no, resizable=no');
  if(wind)
    wind.location.href = extURL;
}
ScreenController.prototype.doTheInvokeServletMethod = function(extURL, successAction, errorAction)
{
  ;
  Browser.callURL(extURL, successAction, errorAction);
}
ScreenController.prototype.doTheCallServer = function(extURL, successAction, errorAction)
{
  ;
  Browser.callServer(extURL, successAction, errorAction);
}
ScreenController.prototype.doTheClosePopup = function(windowName)
{
  ;
  ;
  if(openedWindows[windowName])
  {
    ;
    openedWindows[windowName].close();
  }
  else 
  {
    ;
    top.close();
  }
}
ScreenController.prototype.doNotifyPopupAware = function(screenBroker)
{
  ;
  if (!this.popupAllowed)
    screenBroker.closePopup(null);
}
ScreenController.prototype.shouldNotifyPopupAware = function(screenBroker)
{
    this.doNotifyPopupAware(screenBroker);
}
ScreenController.prototype.shouldLoaded = function()
{
    this.screenBroker.doLoaded();
}
ScreenController.prototype.shouldUnload = function()
{
    this.screenBroker.doUnload();
}
ScreenController.prototype.shouldOpenWindow = function(url, target)
{
    this.doTheOpenWindow(url, target);
}
ScreenController.prototype.doTheOpenWindow = function(url, target)
{
  if (target == null) target = '_blank';
  var wind = window.open('', target);
  if (wind)
  {
    wind.location.href = url;
  	wind.focus();
  }
}
ScreenController.prototype.shouldOpenerReplace = function(internalURL)
{
    this.doTheOpenerReplace(internalURL);
}
ScreenController.prototype.doTheOpenerReplace = function(internalURL)
{
    opener.location.href = internalURL;
}
ScreenController.prototype.shouldAddUserMarker = function(markerId)
{
    if (this.screenBroker.bookmarkable)
        this.doAddUserMarker(markerId);
}
ScreenController.prototype.shouldLogout = function()
{
  this.screenBroker.doLeave();
  this.screenBroker.doLogout();
}
ScreenController.prototype.doTheLogout = function()
{
  Browser.replaceRelative("../credits");
}
ScreenController.prototype.doAddUserMarker = function(markerId)
{
    this.doTheInvokeServletMethod("../multimarker?ACTION=add&MARKER_TYPE=user&MARKER_ID=" + encodeURIComponent(markerId) +
                        "&CONTENT=" + encodeURIComponent(this.contentId));
    this.screenBroker.doAddUserMarker(markerId);
}
