/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function SelectionModel(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
SelectionModel.prototype.init = function(sId)
{
	;
	this.sId = sId;
	this.modelChangeListener = new Array();
	this.values = new Array();
	this.numberOfValues = 0;
	this.active = false;
	this.setAllHandles = new Array();
	this.resetHandles = new Array();
	this.initialActiveValues = new Array();
}
SelectionModel.prototype.getId = function()
{
	return this.sId;
}
SelectionModel.prototype.start = function()
{
	var values = this.getAllValues();
	for (var i = 0; i < values.length; i++)
	{
		if (values[i].isActive())
		{
			this.active = true;
			this.initialActiveValues.push(values[i]);
		}
	}
	this.notifyModelChanged();
}
SelectionModel.prototype.addModelChangeListener = function(listener)
{
	this.modelChangeListener.push(listener);
	listener.setSelectionModel(this);
}
SelectionModel.prototype.notifyModelChanged = function()
{
	for (var i = 0; i < this.modelChangeListener.length; i++)
		this.modelChangeListener[i].selectionModelChanged(this);
}
SelectionModel.prototype.reset = function()
{
	for (var i in this.values)
		this.values[i].reset();
	this.notifyModelChanged();
	this.fireReset();
}
SelectionModel.prototype.addResetHandle = function(action)
{
	this.resetHandles.push(action);
}
SelectionModel.prototype.fireReset = function()
{
	for (var i = 0; i < this.resetHandles.length; i++)
	{
		this.resetHandles[i].invoke();
	}
}
SelectionModel.prototype.setAll = function()
{
	for (var i in this.values)
		this.values[i].set();
	this.notifyModelChanged();
	this.fireSetAll();
}
SelectionModel.prototype.setValuesActive = function(indices)
{
	for (var i = 0; i < this.values.length; i++)
	{
		if (indices[i] != null)
			this.values[i].setActive(true, true);
		else
			this.values[i].setActive(false, true);
	}
	this.notifyModelChanged();
}
SelectionModel.prototype.addSetAllHandle = function(action)
{
	this.setAllHandles.push(action);
}
SelectionModel.prototype.fireSetAll = function()
{
	for (var i = 0; i < this.setAllHandles.length; i++)
	{
		this.setAllHandles[i].invoke();
	}
}
SelectionModel.prototype.registerValue = function(value)
{
	this.values[this.numberOfValues] = value;
	value.setManager(this);
	this.numberOfValues++;
}
SelectionModel.prototype.isActive = function()
{
	return this.active;
}
SelectionModel.prototype.setActive = function(active)
{
	this.active = active;
}
SelectionModel.prototype.getNumberOfValues = function()
{
	return this.numberOfValues;
}
SelectionModel.prototype.getSelectionValueByIndex = function(index)
{
	return this.values[index];
}
SelectionModel.prototype.getIndexOf = function(value)
{
	var index = -1;
	for (var i = 0; i < this.values.length; i++)
	{
		if (this.values[i] == value)
		{
			index = i;
			break;
		}
	}
	return index;
}
SelectionModel.prototype.getActiveValues = function()
{
	var values = new Array();
	for (var i in this.values)
	{
		var value = this.values[i];
		if (value.isActive())
		{
			values.push(value);
		}
	}
	return values;
}
SelectionModel.prototype.getAllValues = function()
{
	return this.values;
}
SelectionModel.prototype.hasSelectedValues = function()
{
	var selected = this.getActiveValues();
	if (selected.lengh == 0)
		return false;
	var selcount = 0;
	for (var i = 0; i < selected.length; i++)
	{
		if (!selected[i].isEmpty())
			selcount ++;
	}
	return selcount > 0;
}
SelectionModelSingle.prototype = new SelectionModel();
SelectionModelSingle.prototype.constructor = SelectionModelSingle;
SelectionModelSingle.superclass = SelectionModel.prototype;
function SelectionModelSingle(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
SelectionModelSingle.prototype.init = function(sId)
{
	SelectionModelSingle.superclass.init.call(this, sId);
	this.initialActiveValue = null;
}
SelectionModelSingle.prototype.process = function(value)
{
	for (var id in this.values)
	{
		if (this.values[id] != value)
			this.values[id].setActive(false, true);
	}
	if (value == null)
		this.active = false;
	else
		this.active = true;
	this.notifyModelChanged();
}
SelectionModelMultiple.prototype = new SelectionModel();
SelectionModelMultiple.prototype.constructor = SelectionModelMultiple;
SelectionModelMultiple.superclass = SelectionModel.prototype;
function SelectionModelMultiple(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
SelectionModelMultiple.prototype.init = function(sId)
{
	;
	SelectionModelMultiple.superclass.init.call(this, sId);
}
SelectionModelMultiple.prototype.process = function()
{
	;
	this.active = false;
	for (var i in this.values)
	{
		if (this.values[i].isActive())
		{
			this.active = true;
			break;
		}
	}
	this.notifyModelChanged();
}
