/*
<DEPENDENCIES>
   <DEPENDS>Logger</DEPENDS>
   <DEPENDS>ScoreEvaluatorStandard</DEPENDS>
   <DEPENDS>ServiceRegistry</DEPENDS>
</DEPENDENCIES>
*/
function AchievementService(id) {
	;
	this.id = id;
	this.scoreStrategy = new ScoreEvaluatorStandard();
	this.numuntouched = 0;
	this.listener = new Array();
  	this.initialized = false;
}
AchievementService.prototype.start = function() {
	if (serviceregistry)
	{
		;
		serviceregistry.registerService('achievementservice', this);
		
		this.initialized = true;
    		this.notifyListener();
	}
}
AchievementService.prototype.setStructureManager = function(structuremanager) {
	;
this.structuremanager = structuremanager;
}
AchievementService.prototype.setEvaluationManager = function(evaluationmanager) {
	;
this.evaluationmanager = evaluationmanager;
}
AchievementService.prototype.getScoreStatisticsTrace = function(structurename, cid) {
	var rootStructureEntry = this.structuremanager.getStructureEntry(structurename,cid); 
	if (!rootStructureEntry)
		return null;
	this.numuntouched = 0;
	var evaluationEntries = new Array();
    this.retrieveEvaluationEntriesTrace(rootStructureEntry, evaluationEntries);
	var staticsEntries = new Array();
	for (var i = 0; i <  evaluationEntries.length; i++) {
		var es = this.scoreStrategy.evaluateSingleScoreTrace(evaluationEntries[i]); 
		staticsEntries.push(es);
   }
   var averageStatistics = this.scoreStrategy.evaluateAverage(this.numuntouched, staticsEntries);
   return averageStatistics;
}
AchievementService.prototype.getScoreStatisticsTraceSingleLevel = function(structurename, cid) {
	var rootStructureEntry = this.structuremanager.getStructureEntry(structurename,cid); 
	if (!rootStructureEntry)
		return null;
	this.numuntouched = 0;
	var evaluationEntries = new Array();
    this.retrieveEvaluationEntriesTraceSingleLevel(rootStructureEntry, evaluationEntries);
	var staticsEntries = new Array();
	for (var i = 0; i <  evaluationEntries.length; i++) {
		var es = this.scoreStrategy.evaluateSingleScoreTrace(evaluationEntries[i]); 
		staticsEntries.push(es);
   }
   var averageStatistics = this.scoreStrategy.evaluateAverage(this.numuntouched, staticsEntries);
   return averageStatistics;
}
AchievementService.prototype.getScoreStatisticsTrack = function(structurename, cid) {
	var rootStructureEntry = this.structuremanager.getStructureEntry(structurename,cid); 
	if (!rootStructureEntry)
		return null;
	this.numuntouched = 0;
	var evaluationEntries = new Array();
    this.retrieveEvaluationEntriesTrack(rootStructureEntry, evaluationEntries);
	var staticsEntries = new Array();
	for (var i = 0; i <  evaluationEntries.length; i++) {
		var es = this.scoreStrategy.evaluateSingleScoreTrack(evaluationEntries[i]); 
		staticsEntries.push(es);
   }
   var averageStatistics = this.scoreStrategy.evaluateAverage(this.numuntouched, staticsEntries);
   return averageStatistics;
}
AchievementService.prototype.retrieveEvaluationEntriesTrace = function(structureEntry, evaluationEntries)
{
	var evalEntry = this.evaluationmanager.getEvaluationEntry(structureEntry.getContentId());
	if (evalEntry && evalEntry.isTrace())
	{
			
			if (evalEntry.hasData())
				evaluationEntries.push(evalEntry);
			else
				this.numuntouched++;
	}
	if (structureEntry.isAdaptiveSequence())
	{
		var numuntouchedbefore = this.numuntouched;
		var evaluationEntriescountbefore = evaluationEntries.length;
		this.retrieveEvaluationEntriesTraceAdaptiveSequence(structureEntry, evaluationEntries);
		if ((evaluationEntries.length == evaluationEntriescountbefore) && (numuntouchedbefore == this.numuntouched))
		{
			
			
			
			var numberofentries = this.retrieveAdaptiveSequenceDefaultPathlength(structureEntry);
			this.numuntouched = this.numuntouched + numberofentries;
            ;
		}
	}
	else if (structureEntry.hasChildren())
	{
		var children = structureEntry.getChildren();
		for (var i = 0; i <  children.length; i++) {
			this.retrieveEvaluationEntriesTrace(children[i], evaluationEntries);
		}
	}
}
AchievementService.prototype.retrieveAdaptiveSequenceDefaultPathlength = function(structureEntry)
{
	var myuntouched = 0;
	if (structureEntry.hasChildren())
	{
    	var fistsubsequence = false;
    	var children = structureEntry.getChildren();
    	for (var i = 0; i < children.length; i++)
    	{
    		var entry = children[i];
    		 ;
    		if (entry.hasChildren())
    		{
    			if (!fistsubsequence)
    			{
    				fistsubsequence = true;
    				myuntouched = myuntouched + this.retrieveAdaptiveSequenceDefaultPathlength(entry);
    			}
    		}
    		else
    		{
    			var evalEntry = this.evaluationmanager.getEvaluationEntry(entry.getContentId());
				if (evalEntry && evalEntry.isTrace())
				{
					
					myuntouched++;
				}
    		}
    	}
	}
	return myuntouched;
}
AchievementService.prototype.retrieveEvaluationEntriesTraceSingleLevel = function(structureEntry, evaluationEntries)
{
	if (structureEntry.hasChildren())
	{
		var children = structureEntry.getChildren();
		for (var i = 0; i <  children.length; i++) {
			var entry = children[i];
			if (!entry.hasChildren())
			{
			 	var evalEntry = this.evaluationmanager.getEvaluationEntry(entry.getContentId());
				if (evalEntry && evalEntry.isTrace())
				{
						
						if (evalEntry.hasData())
							evaluationEntries.push(evalEntry);
						else
							this.numuntouched++;
				}
			}
		}
	}
}
AchievementService.prototype.retrieveEvaluationEntriesTraceAdaptiveSequence = function(structureEntry, evaluationEntries)
{
	if (structureEntry.hasChildren())
	{
		var myEvaluationEntries = new Array();
		var subsequences = new Array();
		var untouched = 0;
		var children = structureEntry.getChildren();
		for (var i = 0; i <  children.length; i++)
		{
			var entry = children[i];
			if (entry.isAdaptiveSequence())
			{
				subsequences.push(entry);
			}
			else
			{
				var evalEntry = this.evaluationmanager.getEvaluationEntry(entry.getContentId());
				if (evalEntry && evalEntry.isTrace())
				{
					
					if (evalEntry.hasData())
						myEvaluationEntries.push(evalEntry);
					else
						untouched++;
				}
			}
		}
		if (untouched > 0 && (children.length - subsequences.length) == untouched)
		{
			
            ;
            ;
            ;
            ;
		}
		else
		{
			var tempEvaluationEntries = new Array();
			var tempTouched = 0;
			for (var i = 0; i <  subsequences.length; i++)
			{
				var subEvaluationEntries = new Array();
				var subTouched = 0;
				;
				this.retrieveEvaluationEntriesTraceAdaptiveSequence(subsequences[i], subEvaluationEntries);
			    if (subEvaluationEntries.length == 0 && subTouched == 0)
			    {
			     	
			    }
			    else
			    {
			    	for (var j = 0; j <  subEvaluationEntries.length; j++)
			    	{
			    		tempEvaluationEntries.push(subEvaluationEntries[j]);
			    	}
			    	tempTouched = tempTouched + subTouched;
			    }
			}
			if (subsequences.length > 0 && (tempEvaluationEntries.length > 0 || tempTouched > 0))
			{
				for (var i = 0; i <  tempEvaluationEntries.length; i++)
				{
					myEvaluationEntries.push(tempEvaluationEntries[i]);
				}
				untouched = untouched + tempTouched;
			}
			else if (subsequences.length > 0)
			{
			 	
            	untouched = 0;
            	myEvaluationEntries = new Array();
			}
			else
			{
			    
			}
			for (var i = 0; i <  myEvaluationEntries.length; i++)
			{
				evaluationEntries.push(myEvaluationEntries[i]);
			}
			this.numuntouched = this.numuntouched + untouched;
			;
			;
		}
	}
}
AchievementService.prototype.retrieveEvaluationEntriesTrack = function(structureEntry, evaluationEntries)
{
	var evalEntry = this.evaluationmanager.getEvaluationEntry(structureEntry.getContentId());
	if (evalEntry)
	{
			
			if (evalEntry.hasData())
				evaluationEntries.push(evalEntry);
			else
				this.numuntouched++;
	}
	if (structureEntry.hasChildren())
	{
		var children = structureEntry.getChildren();
		for (var i = 0; i <  children.length; i++) {
			this.retrieveEvaluationEntriesTrack(children[i], evaluationEntries);
		}
	}
}
AchievementService.prototype.setTraceData = function(cid, nTouched, nTotal, nCorrect, nWrong,
nCorrectStatus, nWrongStatus, nCorrectSystem, nWrongSystem)
{
	;
	var evalEntry = this.evaluationmanager.getEvaluationEntry(cid);
	if (evalEntry)
	{
		var resultData = new ResultData(true, nTouched,nTotal,nCorrect,nWrong,nCorrectStatus, nWrongStatus, nCorrectSystem, nWrongSystem);
		evalEntry.setData(resultData);
	}
}
AchievementService.prototype.setTrackData = function(cid, nTouched, nTotal, nCorrect, nWrong,
nCorrectStatus, nWrongStatus, nCorrectSystem, nWrongSystem)
{
	;
	var evalEntry = this.evaluationmanager.getEvaluationEntry(cid);
	if (evalEntry)
	{
		var trackData = new ResultData(false, nTouched,nTotal,nCorrect,nWrong,nCorrectStatus, nWrongStatus, nCorrectSystem, nWrongSystem);
		evalEntry.setData(trackData);
	}
}
AchievementService.prototype.clearResults = function(cid)
{
	;
	var rootStructureEntry = this.structuremanager.getStructureEntry('lrn',cid); 
	if (!rootStructureEntry)
		return null;
	var evaluationEntries = new Array();
    this.retrieveEvaluationEntriesTrace(rootStructureEntry, evaluationEntries);
	for (var i = 0; i <  evaluationEntries.length; i++) {
		evaluationEntries[i].setData(null);
   }
}
AchievementService.prototype.startTest = function(cid)
{
	;
    this.clearResults(cid);
}
AchievementService.prototype.finishTest = function()
{
	;
}
AchievementService.prototype.registerLoadedListener= function(action) {
	;
	return this.listener.push(action);
}
AchievementService.prototype.notifyListener= function() {
	;
	for (var i = 0; i < this.listener.length; i++)
	{
		this.listener[i].invoke();
	}
}
AchievementService.prototype.isInitialized = function() {
	return this.initialized;
}
